var appController = angular.module('starter.controllers', ['ngSanitize']);

appController.controller('AppCtrl', function($scope,$ionicPlatform, $ionicModal, $timeout,$state,User,definedVariable,$ionicSideMenuDelegate,Auth,ChallengeList,blogList,influencerList) {
    $ionicPlatform.ready(function() {
        // Form data for the login modal
        $ionicSideMenuDelegate.canDragContent(false);
        $scope.loginData = {};

        // Create the login modal that we will use later
        $ionicModal.fromTemplateUrl('templates/login.html', {
            scope: $scope
        }).then(function(modal) {
                $scope.modal = modal;
            });

        // Triggered in the login modal to close it
        $scope.closeLogin = function() {
            $scope.modal.hide();
        };

        // Open the login modal
        $scope.login = function() {
            $scope.modal.show();
        };

        if (User.getUserInfo().length > 0){
            $scope.userInfo = User.getUserInfo()[0];

        }else{
            User.getUserInfo().then(function(response){
               $scope.userInfo = response[0];

            });
        }
        $scope.$watch(function(){
            return $ionicSideMenuDelegate.getOpenRatio();
        }, function(newValue, oldValue) {
            if (newValue == 0){
                $scope.hideLeft = true;
            } else{
                $scope.hideLeft = false;
            }
        });
        $scope.$on('user:updated', function(event,data) {
            // you could inspect the data to see if what you care about changed, or just update your own scope
            $scope.userInfo = User.getUserInfo()[0];
        });
        $scope.adminUrl = definedVariable.getAdminRootClean();
        //$scope.userInfo = User.getUserInfo();

        // Perform the login action when the user submits the login form
        $scope.doLogin = function() {


            // Simulate a login delay. Remove this and replace with your login
            // code if using a login system
            var time = $timeout(function() {
                $scope.closeLogin();
            }, 1000);

        };
        $scope.sideMenuLists = [
            {sideMenuName:"Home",url:"#/app/challengelist"},
            {sideMenuName:"Challenge Map",url:"#/app/home"},
            {sideMenuName:"Hungry News",url:"#/app/blog"},
            {sideMenuName:"Hungry Deals",url:"#/app/deals"},
            {sideMenuName:"My List",url:"#/app/favourite"},
            //{sideMenuName:"Food Festivals",url:"#/app/festivalList"},
            //{sideMenuName:"Influencers",url:"#/app/influencersList"},
            //{sideMenuName:"Shop",url:""},
            {sideMenuName:"My Settings",url:"#/app/settings"},
            {sideMenuName:"About Us",url:"#/app/about"}

        ];
        var loggedIn = Auth.isLoggedIn();
        if (loggedIn != null){
            $scope.loggedIn = true;
        }else{
            $scope.loggedIn = false;
        }
        $scope.goLogin = function(){
            ChallengeList.clearMemory();
            User.emptyUser();
            blogList.clearMemory();
            influencerList.clearMemory();
            $state.go('login');
        };
        $scope.goToPage = function($index){

            $state.go($scope.sideMenuLists[$index].url);
        };


    });

})


    .controller('mapCtrl', function($scope,$ionicPlatform,$ionicNavBarDelegate,$timeout,$stateParams,addMarker,ChallengeList,dataService,$ionicLoading) {
        $ionicPlatform.ready(function() {
            document.getElementById('leftSideMenu').style.visibility = "hidden";

            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Map View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Map View');
            }else{
                console.log("Analytics not set");
            }

            var map = null;
            $scope.goBack = function(){
                $timeout.cancel(time);
                $ionicNavBarDelegate.back();
            };
            if ($stateParams.type == "favourite"){
                var currentList = null;
                var locations = [];
                var latitude = null;
                var longitude = null;
                $ionicLoading.show({
                    template: '<i class=""></i>Loading...'
                });
                var chall = dataService.getChallangeById({challenge_id:$stateParams.currentIndex});
                chall.then(function(response){
                    console.log("CHALLENGE : " + JSON.stringify(response));
                    currentList = response[0];
                    locations = [currentList];
                    latitude = currentList.latitude;
                    longitude = currentList.longitude;
                    $scope.challengeName = currentList.challenge_name;
                    $ionicLoading.hide();
                });
            }else{
                var currentIndex = $stateParams.currentIndex;
                var currentList = ChallengeList.getCurrentList()[currentIndex];
                var locations = [currentList];
                var latitude = currentList.latitude;
                var longitude = currentList.longitude;
                $scope.challengeName = currentList.challenge_name;
            }

            $scope.isAndroid = /(android)/i.test(navigator.userAgent) ? true : false;
            $scope.openWebView = function(target){
                console.log("ADDR : "+JSON.stringify(currentList));
                var address = currentList.street +"," +currentList.city + ","+currentList.state + ","+currentList.country;
                if ($scope.isAndroid){
                    var link = "geo:"+latitude+","+longitude+"?q="+address;
                }else{
                    var link = "http://maps.apple.com/?daddr="+address;
                }


                var ref = window.open(link, '_system', 'location=no');
            };

           // var locations = [{longitude:$stateParams.longitude,latitude:$stateParams.latitude, title:"mapTitle"},{longitude:-85.70089,latitude:38.16110, title:"second"}];
            var time = $timeout(function() {
                var div = document.getElementById("gMap");
                map = plugin.google.maps.Map.getMap(div);
                map.clear();
                map.setClickable(true);
                /*var latlng = new plugin.google.maps.LatLng($stateParams.latitude,$stateParams.longitude);
                 console.log(latlng);
                 map.addMarker(
                 {
                 'position':latlng,
                 'title':"This is a test"

                 },function(marker){
                 console.log("marker added");
                 marker.showInfoWindow();
                 });*/
                var test =  addMarker.addMarkerList(map,locations);
            }, 1000);



        });
    })
   /* .controller('PlaylistCtrl', function($scope, $stateParams) {
    })
*/
    .controller('checkLocationCtrl', function($scope, $state, $location,$ionicPlatform,$ionicSideMenuDelegate,$ionicLoading,countryList,Auth,StorageService,$interval) {


        $ionicPlatform.ready(function() {
            function checkConnection() {
                var networkState = navigator.connection.type;

                var states = {};
                states[Connection.UNKNOWN]  = 'Unknown connection';
                states[Connection.ETHERNET] = 'Ethernet connection';
                states[Connection.WIFI]     = 'WiFi connection';
                states[Connection.CELL_2G]  = 'Cell 2G connection';
                states[Connection.CELL_3G]  = 'Cell 3G connection';
                states[Connection.CELL_4G]  = 'Cell 4G connection';
                states[Connection.CELL]     = 'Cell generic connection';
                states[Connection.NONE]     = 'No network connection';

                if (states[networkState] != 'No network Connection'){
                    return true;
                }
                return false;

            };

            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Check Location');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Check Location');
            }else{
                console.log("Analytics not set");
            }
            var loggedIn = Auth.isLoggedIn();


            // $scope.submit = utils.submitForm;


            window.scope = $scope;
            $ionicLoading.show({
                template: '<i class=""></i>Loading...'
            });
            var notLoggedIn = true;
            var checkComplete = false;
            //StorageService.unset('didTutorial');
            if (loggedIn != null && loggedIn.auth_token !== 'undefined' && StorageService.get('didTutorial') === "true"){
                 notLoggedIn = false;
                 Auth.checkLogin({authToken:String(loggedIn.auth_token)}).then(function(data){
                     checkComplete = true;
                     if (data.data.status == "success"){

                        $location.path('/app/challengelist');
                     }else{
                        notLoggedIn = true;

                        Auth.logout();
                     }

                 },function(error){
                     checkComplete = true;
                     notLoggedIn = true;
                 });
                /*if (!Auth.checkLogin({authToken:String(loggedIn.auth_token)})){
                 Auth.logout();
                 }else{
                 $location.path('/app/home');
                 }*/

            }else{
                notLoggedIn = true;
                checkComplete = true;
                Auth.logout();
            }
            //console.log("IN CONTROLLER: "+JSON.stringify(list));
            $scope.countryList = [
                {countryName:"Abilene, TX" ,longitude:"0",latitude:"0"},
                {countryName:"Akron / Canton",longitude:"1",latitude:"1"},
                {countryName:"Albany  / Capital Region",longitude:"2",latitude:"2"},
                {countryName:"Albuquerque",longitude:"3",latitude:"3"},
                {countryName:"Allentown /Reading",longitude:"4",latitude:"4"},
                {countryName:"Amarillo",longitude:"5",latitude:"5"},
                {countryName:"Anchorage",longitude:"6",latitude:"6"},
                {countryName:"Anchorage",longitude:"7",latitude:"7"}

            ];
            var list = countryList.setList();
            list.then(function(result){

                $scope.countryList =  result.data;
            });
            var inter;
            function startRedirecting(){
                inter = $interval(function(){
                    if (notLoggedIn && checkComplete){
                        redirectCheckSuccess();
                    }
                },100)
                // $location.path('/login');

            }
            var redirectCheckSuccess = function(){
                $interval.cancel(inter);
                inter = undefined;
                $state.go('login');
            };
            function onSuccess(position) {
                /* alert('Latitude: '          + position.coords.latitude          + '\n' +
                 'Longitude: '         + position.coords.longitude         + '\n' +
                 'Altitude: '          + position.coords.altitude          + '\n' +
                 'Accuracy: '          + position.coords.accuracy          + '\n' +
                 'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
                 'Heading: '           + position.coords.heading           + '\n' +
                 'Speed: '             + position.coords.speed             + '\n' +
                 'Timestamp: '         + position.timestamp                + '\n');

                 */

                StorageService.set('current_user_longitude',position.coords.longitude);
                StorageService.set('current_user_latitude',position.coords.latitude);


                $ionicLoading.hide();
                startRedirecting();
            };

            // onError Callback receives a PositionError object
            //
            function onError(error) {

                $ionicLoading.hide();
            }
            $scope.toggleSideMenu = function(){

                $ionicSideMenuDelegate.toggleLeft();
            };
            // $location.path('/login');
            if (!checkConnection()){
                navigator.app.exitApp();
            }
            else{
                if ("geolocation" in navigator){


                   navigator.geolocation.getCurrentPosition(onSuccess, onError);
                }
                else{
                    //$ionicLoading.hide();
                }
            }
            $scope.myForm = {};
            $scope.data = {};

            var utils = {
                submitForm:function(){
                    StorageService.set('current_user_city',$scope.data.city);
                    StorageService.set('current_user_state',$scope.data.state);
                    StorageService.set('current_user_country',$scope.data.country);
                    //$location.path('/login');
                    // $state.go('/login','slide');
                    $state.go('login');
                    //$location.path('/login')
                },
                test:function(){
                    if (loggedIn.auth_token !== 'undefined'){
                        console.log("AUTH TOKEN SET : "+loggedIn.auth_token);
                        var promise = Auth.checkLogin({authToken:String(loggedIn.auth_token)}).then(function(data){

                            if (data){
                                $location.path('/app/challengeList');
                            }else{
                                Auth.logout();
                            }
                            return data;
                        },function(error){
                            return error;
                        });
                        /*if (!Auth.checkLogin({authToken:String(loggedIn.auth_token)})){
                         Auth.logout();
                         }else{
                         $location.path('/app/home');
                         }*/

                    }else{

                    }

                }

            };
            /*$scope.$watch('data.locationDetails',function(oldValue,newValue){
             //alert(newValue);
             if (newValue != oldValue && newValue != null){
             $scope.data = newValue;
             alert('clicked');
             utils.submitForm();
             }


             });*/
            $scope.locationChanged = function(selected){

                $scope.data.state = selected.state;
                $scope.data.city = selected.city;
                $scope.data.country = selected.country;
                utils.submitForm();
            };
            $scope.test = utils.test;
            $ionicLoading.hide();
            //checkConnection();
            /*var div = document.getElementById("map_canvas");
             map = plugin.google.maps.Map.getMap(div);
             */
        });


    })
    .controller('LoginCtrl', ['$scope', 'Auth', '$location', '$ionicPlatform','StorageService','$ionicModal','$ionicPopup','$ionicActionSheet','countryList',
        '$ionicLoading','$ionicPopup','$ionicSlideBoxDelegate',
        function($scope, Auth, $location, $ionicPlatform, StorageService,$ionicModal,$ionicPopup,$ionicActionSheet,countryList,$ionicLoading,$ionicPopup,$ionicSlideBoxDelegate) {
            $ionicPlatform.ready(function() {

                window.scope = $scope;
                if (typeof window.analytics !== 'undefined'){
                    window.analytics.trackView('Login View');
                }else if (typeof analytics !== 'undefined'){
                    analytics.trackView('Login View');
                }else{
                    console.log("Analytics not set");
                }
                $scope.credentials = {username: "", password: ""};
                $scope.userData = {};
                $scope.reset = {};
                $scope.countryList = [];
                var list = countryList.setList();
                list.then(function(result){

                    $scope.countryList =  result.data;
                });


                $scope.selectedCity = StorageService.get('current_user_city');
                $scope.locationChange = function (city){

                    $scope.userData.city = city.city;
                    $scope.userData.state = city.state;
                    $scope.userData.country = city.country;
                };
                var imageURI = null;
                $ionicModal.fromTemplateUrl('templates/registerUser.html', {
                    scope: $scope
                }).then(function(modal) {
                        $scope.modal = modal;
                    });

                $ionicModal.fromTemplateUrl('templates/forgot_password.html', {
                    scope: $scope
                }).then(function(modal) {
                        $scope.resetModal = modal;
                    });
                $scope.closeForgot = function(){
                    $scope.resetModal.hide();
                };
                var takePicture = function(){
                    navigator.camera.getPicture(onSuccess, onFail, {
                        quality: 50,
                        destinationType: Camera.DestinationType.FILE_URI,
                        targetWidth: 200,
                        targetHeight: 200
                    });
                };
                var chooseFromGallery = function(){
                    navigator.camera.getPicture(onSuccess, onFail, {
                        quality: 50,
                        destinationType: Camera.DestinationType.FILE_URI,
                        sourceType: Camera.PictureSourceType.PHOTOLIBRARY,     // 0:Photo Library, 1=Camera, 2=Saved Photo Album
                        targetWidth:200,
                        targetHeight:200
                    });
                };
                function onSuccess(FILE_URI) {
                    var image = document.getElementById('myImage');
                    //image.src = "data:image/jpeg;base64," + imageData;
                    image.src = FILE_URI;
                    imageURI = FILE_URI;
                    Auth.upload_profile_pic(imageURI);

                }

                function onFail(message) {
                    alert('Failed because: ' + message);
                }
                $scope.leftButtonText = "Skip";
                $scope.rightButtonText = "Next";
                var modalOptions = {
                    showActions:function(){
                        $ionicActionSheet.show({
                            buttons: [
                                { text: 'Camera' },
                                { text: 'Gallery' }
                            ],

                            titleText: 'Upload Picture',
                            cancelText: 'Cancel',
                            cancel: function() {

                                // add cancel code..
                            },
                            buttonClicked: function(index) {
                                if (index == 0){
                                    takePicture();
                                }
                                else if (index == 1){
                                    chooseFromGallery();
                                }

                                return true;
                            }
                        });

                    },
                    leftButton:function(){
                        if ($scope.slideIndex == 0){

                            $scope.introModal.hide();
                        }else{

                            $ionicSlideBoxDelegate.previous();
                        }
                    },
                    rightButton:function(){
                        if ($scope.slideIndex == 2){

                            $scope.introModal.hide();
                        }else{

                            $ionicSlideBoxDelegate.next();
                        }
                    },
                    reset:function(){
                        if ($scope.reset.registerForm.$valid){
                            Auth.changePassword($scope.reset).then(function(response){
                                console.log("RESPONSE "+JSON.stringify(response));
                                if (response.status == "success"){
                                    var alertPopup = $ionicPopup.alert({
                                        title: 'Success!',
                                        template: response.response
                                    });
                                    alertPopup.then(function(res) {
                                        $scope.resetModal.hide();
                                    });
                                }else{
                                    var alertPopup = $ionicPopup.alert({
                                        title: 'Error!',
                                        template: response.response
                                    });
                                    alertPopup.then(function(res) {

                                    });
                                }
                            });
                        }else{
                            var alertPopup = $ionicPopup.alert({
                                title: 'Error!',
                                template: "INVALID"
                            });
                            alertPopup.then(function(res) {

                            });
                        }
                    },
                    submit:function(){
                       // dataService.upload_profile_pic(imageURI);
                        /*
                         THIS IS FOR ANDROID
                         */
                        $scope.userData.source = "android";
                        /*
                        REmove this section For ios
                         */
                        if ($scope.userData.registerForm.$valid){
                            if ($scope.userData.conf == $scope.userData.password){
                                $ionicLoading.show({
                                    template: '<i class=""></i>Loading...'
                                });
                                if (imageURI != null){
                                    $scope.userData.media_id = Auth.getPicId();
                                    /*
                                    THIS IS FOR ANDROID
                                     */
                                    $scope.userData.source = "android";
                                    Auth.register($scope.userData).then(function(response){

                                        if (response.data.status == "success"){
                                            StorageService.set('hungryAuth',JSON.stringify({auth_token:response.data.auth_token}));
                                            $ionicLoading.hide();
                                            utils.registrationSuccessfull();
                                        }else{

                                            var alertPopup = $ionicPopup.alert({
                                                title: 'Error!',
                                                template: response.data.response
                                            });
                                            alertPopup.then(function(res) {
                                                $ionicLoading.hide();
                                            });
                                        }
                                    });
                                }else{
                                    Auth.register($scope.userData).then(function(response){
                                        if (response.data.status == "success"){
                                            StorageService.set('hungryAuth',JSON.stringify({auth_token:response.data.auth_token}));
                                            utils.registrationSuccessfull();
                                        }
                                        else{
                                            var alertPopup = $ionicPopup.alert({
                                                title: 'Error!',
                                                template: response.data.response
                                            });
                                            alertPopup.then(function(res) {
                                                $ionicLoading.hide();
                                            });
                                        }
                                    });
                                }
                            }
                        }else{
                            var alertPopup = $ionicPopup.alert({
                                title: 'Error!',
                                template: "Please check all your fields"
                            });
                            alertPopup.then(function(res) {
                                $ionicLoading.hide();
                            });
                        }
                        $ionicLoading.hide();
                    }
                };
                // Triggered in the login modal to close it
                $scope.modalActions = modalOptions;
                $scope.closeLogin = function() {
                    $scope.modal.hide();
                };

                var utils = {
                    createNewUser:function(){
                        $scope.modal.show();
                    },
                    registrationSuccessfull:function(){
                        $scope.modal.hide();
                        $location.path('/app/challengelist');

                    },
                    forget_password:function(){
                        $scope.resetModal.show();
                    },
                    signIn:function(){
                        $ionicLoading.show({
                            template: '<i class=""></i>Loading...'
                        });
                        Auth.login($scope.credentials).success(function(data){
                            if (data.status == 'success'){
                                $ionicLoading.hide();
                                $location.path('/challengeList');
                            }
                            else{

                                var alertPopup = $ionicPopup.alert({
                                    title: 'Error!',
                                    template: data.data.error_msg
                                });
                                alertPopup.then(function(res) {
                                    $ionicLoading.hide();
                                });
                            }
                        });

                        //$location.path('/app/home');
                    },
                    skipSignIn:function(){
                      $location.path('/app/challengelist');
                    },
                    fbSignIn:function(){
                       /* facebookConnectPlugin.login(["public_profile","email","user_location"],
                            fbLoginSuccess,
                            function (error) {
                                var alertPopup = $ionicPopup.alert({
                                    title: 'Error!',
                                    template: JSON.stringify(error)
                                });
                                alertPopup.then(function(res) {

                                });
                            }
                        );*/
                        facebookConnectPlugin.getLoginStatus(statusSucess,statusError);
                        /*facebookConnectPlugin.login(["public_profile"],
                            fbLoginSuccess,
                            function (error) {
                                alert("" + error);
                            }
                        );*/
                        //facebookConnectPlugin.logout(fbLoginSuccess , function(error){alert(error);});
                    }
                };
                var statusSucess = function(userData){
                    //console.log("UserData "+JSON.stringify(userData));
                    if (userData.status == "connected"){
                        var longitude = StorageService.get('current_user_longitude');
                        var latitude = StorageService.get('current_user_latitude');

                        facebookConnectPlugin.getAccessToken(function(token){
                            var response = Auth.fb_login({token:token,longitude:longitude,latitude:latitude,source:"android"}).then(function(response){
                                console.log("FB RESPONSE "+JSON.stringify(response));
                                if (response.status == "success"){
                                    StorageService.set('hungryAuth',JSON.stringify({auth_token:response.response.auth_token}));
                                    $location.path('/challengelist')
                                }else{
                                    facebookConnectPlugin.logout(fbLoginAttempt , function(error){fbLoginAttempt();});
                                }
                            });
                        });


                        //var response = Auth.fb_login(userData);
                    }else{
                        facebookConnectPlugin.login(["public_profile","email","user_location"],
                            fbLoginSuccess,
                            function (error) {
                                var alertPopup = $ionicPopup.alert({
                                    title: 'Error!',
                                    template: JSON.stringify(error)
                                });
                                alertPopup.then(function(res) {

                                });
                            }
                        );
                    }
                };
                var fbLoginAttempt = function(){
                    facebookConnectPlugin.login(["public_profile","email","user_location"],
                        fbLoginSuccess,
                        function (error) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Error!',
                                template: JSON.stringify(error)
                            });
                            alertPopup.then(function(res) {

                            });
                        }
                    );
                }
                var statusError = function(err){
                    facebookConnectPlugin.login(["public_profile","email","user_location"],
                        fbLoginSuccess,
                        function (error) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Error!',
                                template: error
                            });
                            alertPopup.then(function(res) {

                            });
                        }
                    );
                };
                var fbLoginSuccess = function (userData) {
                    var longitude = StorageService.get('current_user_longitude');
                    var latitude = StorageService.get('current_user_latitude');
                    var current_city = StorageService.get('current_user_city');
                    var current_state = StorageService.get('current_user_state');
                    var current_country = StorageService.get('current_user_country');
                    facebookConnectPlugin.getAccessToken(function(token){
                        $ionicLoading.show({
                            template: '<i class=""></i>Loading...'
                        });
                        var response = Auth.fb_login({token:token,longitude:longitude,latitude:latitude,city:current_city,state:current_state,country:current_country,source:"android"}).then(function(response){

                            if (response.status == "success"){
                                StorageService.set('hungryAuth',JSON.stringify({auth_token:response.response.auth_token}));
                                $ionicLoading.hide();
                                $location.path('/app/challengelist')
                            }else{
                                $ionicLoading.hide();
                                var alertPopup = $ionicPopup.alert({
                                    title: 'Error!',
                                    template: response.response.response
                                });
                                alertPopup.then(function(res) {

                                });

                            }
                        });
                    });
                };

                $scope.goToRegistration = utils.createNewUser;
                $scope.signInUser = utils.signIn;
                $scope.fbSignIn = utils.fbSignIn;
                $scope.forgot_password = utils.forget_password;
                $scope.isAndroid = /(android)/i.test(navigator.userAgent) ? true : false;
                $scope.skipSignIn = utils.skipSignIn;
                /*$scope.loginUser = function() {

                 angular.element('#error-message').hide();

                 Auth.login({
                 username: $scope.credentials.username,
                 password: $scope.credentials.password,
                 remember: $scope.credentials.remember
                 }).success(function(data) {

                 if (data.error) {
                 angular.element('#error-message').show();
                 } else {
                 console.log("You are signed in!");
                 /*console.log($scope.userData);
                 $scope.userData.username = data.user.username;
                 $scope.userData.id = data.user.id;
                 console.log($scope.userData);*/
                /*        $scope.credentials = {};
                 $location.path('/');
                 }
                 });
                 };*/
                if (StorageService.get("didTutorial") === null){
                    StorageService.set("didTutorial","true");

                    var init = function(){
                        $ionicModal.fromTemplateUrl('templates/intro.html', {
                         scope: $scope
                         }).then(function(modal) {
                         $scope.introModal = modal;
                                $scope.introModal.show();
                               // $ionicSlideBoxDelegate.update();
                         });

                    };
                    init();
                    $scope.next = function() {
                        $ionicSlideBoxDelegate.next();
                    };
                    $scope.closeIntro = function(){
                        $scope.introModal.hide();
                    }
                    $scope.previous = function(){
                        $ionicSlideBoxDelegate.previous();
                    }

                    $scope.slideIndex = 0;
                    // Called each time the slide changes
                    $scope.slideChanged = function(index) {
                       $scope.slideIndex = index;
                        if (index == 0){
                            $scope.leftButtonText = "Skip";

                        }else{
                            $scope.leftButtonText = "Previous";

                        }
                        if (index == 2){
                            $scope.rightButtonText = "Start";

                        }else{
                            $scope.rightButtonText = "Next";

                        }
                    };
                }
            });

        }])
    .controller('registerCtrl', ['$scope', 'Auth', '$location', '$ionicPlatform','$stateParams', function($scope, Auth, $location, $ionicPlatform,StorageService,$stateParams) {
        $ionicPlatform.ready(function() {
            window.scope = $scope;
            var options = {
                date: new Date(),
                mode: 'date'
            };
// calling show() function with options and a result handler
            datePicker.show(options, function(date){

            });
            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Register View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Register View');
            }else{
                console.log("Analytics not set");
            }
        });


    }])

    .controller('homeCtrl',['$scope','$stateParams','$ionicPlatform','$timeout','$ionicSideMenuDelegate','dataService','Auth' ,'definedVariable','ChallengeList','countryList','addMarker',
        '$ionicModal','User','adMobHelper','$ionicScrollDelegate','StorageService','$filter',
        function($scope, $stateParams,$ionicPlatform,$timeout,$ionicSideMenuDelegate,dataService,Auth,definedVariable,ChallengeList,
                 countryList,addMarker,$ionicModal,User,adMobHelper,$ionicScrollDelegate,StorageService,$filter) {
        $ionicPlatform.ready(function() {
            /*
                Admob setup goes here
             */
            console.log("DEVICE HEIGHT "+ window.screen.height);
            if (window.screen.height < 500){
                $scope.screenHeightClass = 'iphone_four_height';
            }else{
                $scope.screenHeightClass = 'map_default_height';
            }

            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Challenge Map View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Challenge Map View');
            }else{
                console.log("Analytics not set");
            }


            var AdMob;
            var createBanner = function(){
                if (window.AdMob ){

                    if (navigator.userAgent !== undefined){
                        var admobid = ( /(android)/i.test(navigator.userAgent) ) ? adMobHelper.getAndroid() : adMobHelper.getIos();
                    }else{
                        var admobid = adMobHelper.getAndroid();
                    }
                    console.log(admobid.banner);
                    AdMob = window.AdMob;

                    AdMob.createBanner({
                            adId: admobid.banner,
                            adSize:AdMob.SMART_BANNER,
                            position:AdMob.AD_POSITION.BOTTOM_CENTER,
                            overlap: true,
                            autoShow:true,
                            success:function(){console.log("Success Ad");},
                            error:function(error){console.log("Error ad: "+error);}

                        }
                    );
                }else{
                    console.log("I am here");
                }
            };

            createBanner();


           /* var initAd = function(){
                var defaultOptions = {
                    // bannerId: admobid.banner,
                    // interstitialId: admobid.interstitial,
                    // adSize: 'SMART_BANNER',
                    // width: integer, // valid when set adSize 'CUSTOM'
                    // height: integer, // valid when set adSize 'CUSTOM'
                    position: AdMob.AD_POSITION.BOTTOM_CENTER,
                    // offsetTopBar: false, // avoid overlapped by status bar, for iOS7+
                    bgColor: 'black', // color name, or '#RRGGBB'
                    // x: integer,		// valid when set position to 0 / POS_XY
                    // y: integer,		// valid when set position to 0 / POS_XY
                    isTesting: true // set to true, to receiving test ad for testing purpose
                    // autoShow: true // auto show interstitial ad when loaded, set to false if prepare/show
                };
                AdMob.setOptions( defaultOptions );

            };
            var createBanner = function(){
                if(AdMob) AdMob.createBanner( {
                    adId:admobid.banner,
                    position:AdMob.AD_POSITION.BOTTOM_CENTER,
                    autoShow:true}

                );
            };*/

            /*
            Admob ends
            */
            $ionicSideMenuDelegate.canDragContent(false);
            var map = null;
            var preSetFilterView = false;
            window.scope = $scope;
            /*THIS IS THE BASIC CATEGORY LIST*/
            $scope.filterList = definedVariable.getFilterList();
            $scope.showFilterSelected = 0;
            $scope.filSel = 0;
            $scope.changeFilter = function(index){
                $scope.showFilterSelected = index;
                $scope.filSel = index;
                lastSelection = index;
                $scope.filSel = index;
                if (index == 0){
                    $scope.challengeList = ChallengeList.getList();
                }else if (index == 1){
                    utils.getChallengeOnly();
                }else if (index == 2){
                    utils.getContestOnly();
                }else if (index == 3){
                    utils.getFestivalOnly();
                }
            };
            /*Basic Category Ends*/
            /**
             * This is where custom filter begins
             * @type {Array}
             */
            var filterIconList = [
                {not_selected:"img/all-inactive@3x.png" , selected:"img/all-active@3x.png"},
                {not_selected:"img/challenges-inactive@3x.png" , selected:"img/challenges-active@3x.png"},
                {not_selected:"img/contests-inactive@3x.png" , selected:"img/contests-active@3x.png"},
                {not_selected:"img/festivals-inactive@3x.png", selected:"img/festivals-active@3x.png"},
                {not_selected:"img/more-inactive@3x.png", selected:"img/more-active@3x.png"}
            ];
            $scope.fTest = filterIconList;
            var delegate = $ionicScrollDelegate.$getByHandle('small');
            var scroll_position = 0;


            var startAtX = 0;
            $scope.getXStart = function(){
                return startAtX;
            }
            $scope.clickFilter = function($index){
                if ($index == 4){
                    $scope.showFilterDetail();
                }else{
                    $scope.filSel = $index;
                    lastSelection = $index;
                    startAtX = (100*$index);
                    $scope.changeFilter($index);
                    delegate.scrollTo(100*$scope.filSel,0,true);
                    var time = $timeout(function() {
                        $scope.showFilterStatus = false;
                        return true;
                    }, 1000);
                }


            };

            $scope.showFilterStatus = false;

            $scope.showFilter = function(){

                //delegate.scrollTo(100*$scope.filSel, 0 , false);
                console.log("SCOPE FILE SEL "+$scope.filSel);
                if ($scope.showFilterStatus == false){
                    preSetFilterView = true;
                    $scope.showFilterStatus = true;
                    //delegate.scrollToRememberedPosition();
                    if (map != null){
                        map.setClickable(false);
                    }
                    /*delegate.scrollTo(100*$scope.filSel, 0 , false);*/
                }
                else{
                    $scope.showFilterStatus = false;
                    preSetFilterView = false;
                    if (map != null){
                        map.setClickable(true);
                    }
                    //$scope.clickFilter(sel);
                }
                console.log("SCOPE FILE SEL "+$scope.filSel);
            };
            var lastSelection = 0;

            $scope.testSwipe = function(){

                scroll_position = delegate.getScrollPosition().left;
                console.log("SCOPE SCROLL POSITION "+scroll_position);
                if (preSetFilterView){
                    delegate.scrollTo(100*lastSelection, 0 , true);
                    preSetFilterView = false;
                }
                else if (scroll_position < 60 && $scope.showFilterStatus == true){
                    $scope.filSel = 0;
                }else if (scroll_position >60 && scroll_position<140 && $scope.showFilterStatus == true){
                    $scope.filSel = 1;
                }else if (scroll_position > 140 && scroll_position < 240 && $scope.showFilterStatus == true){
                    $scope.filSel = 2;
                }else if (scroll_position > 240 && $scope.showFilterStatus == true){
                    $scope.filSel = 3;
                }

                /*else if (scroll_position > 240 && scroll_position < 340){
                    $scope.filSel = 3;
                }else{
                    $scope.filSel = 4;
                }*/
                if ($scope.filSel < 4 && $scope.showFilterStatus == true && lastSelection != $scope.filSel){
                    lastSelection = $scope.filSel;
                    startAtX = (100*$scope.filSel);
                    delegate.scrollTo(100*$scope.filSel, 0 , true);
                    $scope.changeFilter($scope.filSel);
                    //delegate.rememberScrollPosition('position-set');

                }else if ($scope.filSel == 4 && $scope.showFilterStatus == true && lastSelection != $scope.filSel){
                    lastSelection = $scope.filSel;
                    delegate.scrollTo(100*$scope.filSel, 0 , true);
                    var time = $timeout(function() {
                        $scope.showFilterDetail();
                        return true;
                    }, 1000);
                    //
                }
                console.log("SCOPE TEST SWIPE SELE" + $scope.filSel);
              // alert("INSIDE TEST SWIPE " + JSON.stringify(delegate.getScrollPosition()));

            };



            /*this section is for tag filter*/
            var taglist = dataService.getTags();
            if (taglist.length >= 0){
                $scope.tagList = taglist;
            }else{
                taglist.then(function(response){

                    $scope.tagList = response;
                });
            }
            $scope.tagForChallenge = [];
            var tagForChallenge = dataService.getTagForChallenge();
            if (tagForChallenge.length >=0){
                $scope.tagForChallenge = tagForChallenge;
            }else{
                tagForChallenge.then(function(response){
                    $scope.tagForChallenge = response;
                });
            }

            /*Tag Filter Complete*/


            /*SUB CATEGORY FUNCTION BEGINS*/
           /* var subCatList = dataService.getSubCat();

            if (subCatList.length >= 0){
                $scope.subCatList = subCatList;
            }else{
                subCatList.then(function(response){

                    $scope.subCatList = response;
                });
            }

            var subCatForChallenge = dataService.getSubCatForChallenge();
            if (subCatForChallenge.length >=0){
                $scope.subCatForChallenge = subCatForChallenge;
            }else{
                subCatForChallenge.then(function(response){
                    $scope.subCatForChallenge = response;
                })
            }*/

            /*Sub Category Function Ends*/

            $scope.filterTagList = [];
            $scope.filterCategoryList = [];
            $scope.filterSubCategoryList = [];
            // Triggered in the login modal to close it


            /* THIS IS FOR SIDE MENU BEGIN*/
            $scope.toggleRight = function() {

                $ionicSideMenuDelegate.toggleRight();
            };
            /*Side menu function ends*/

            var modalOptions = {
                closeModal:function(){
                    if (map != null){
                        map.setClickable(true);
                    }
                    $scope.modal.hide();
                },
                filterTags:function(tag){
                    User.setTagFilters(tag);
                    if (User.getSubCatFilters().length > 0 || User.getTagFilters().length > 0){
                        $scope.defaultMessage = "Sorry, there are no results that match your search.";
                    }
                },
                filterSubCat:function(subCat){
                    User.setSubCatFilters(subCat);
                    if (User.getSubCatFilters().length > 0 || User.getTagFilters().length > 0){
                        $scope.defaultMessage = "Sorry, there are no results that match your search.";
                    }
                    $scope.challengeList = utils.filterChallengeList($scope.originalChallengeList);
                },
                tagSelectClass:function(tag){
                    var styleClass= 'button button-light';

                    var tempFilteredTag = User.getTagFilters();
                    angular.forEach(tempFilteredTag,function(value,key){
                        if (tag.tag_id === value.tag_id){
                            styleClass =  'button button-assertive';
                            return;
                        }
                    });
                    return styleClass;
                },
                subCatSelectClass:function(tag){
                    var styleClass= 'button button-light';

                    var tempFilteredTag = User.getSubCatFilters();
                    angular.forEach(tempFilteredTag,function(value,key){

                        if (tag.sub_id === value.sub_id){

                            styleClass =  'button button-assertive';
                        }
                    });
                    return styleClass;
                }
            };
            $scope.modalActions = modalOptions;

            var time = $timeout(function() {
                var div = document.getElementById("mapView");
                map = plugin.google.maps.Map.getMap(div);
                map.clear();
                map.setClickable(true);
                utils.insertMarker();
                return true;
            }, 1000);

            var list = countryList.setList();
            if (list.length !="undefined" && list.length >= 0){
                $scope.countryList = list;
                if ($scope.countryList[0].city != "Use Current Location"){
                    $scope.countryList.splice(0,0,{city:"Use Current Location",state:"",country:"Location",group:"Use Current Location"});
                }
                $scope.countryList = $filter('groupByCountry')($scope.countryList);

            }else{
                list.then(function(result){

                    $scope.countryList =  result.data;
                    if ($scope.countryList[0].city != "Use Current Location"){
                        $scope.countryList.splice(0,0,{city:"Use Current Location",state:"",country:"Location",group:"Use Current Location"});
                    }
                    $scope.countryList = $filter('groupByCountry')($scope.countryList);

                });
            }
            $scope.toggleSideMenu = function(){
                if ($ionicSideMenuDelegate.isOpenLeft())
                {
                    $scope.showFilterStatus = false;
                    //AdMob.showBanner();
                    createBanner();
                    document.getElementById('leftSideMenu').style.visibility = "hidden";
                    map.setClickable(true);
                    $ionicSideMenuDelegate.toggleRight();
                }
                else{
                    $scope.showFilterStatus = false;
                    //AdMob.hideBanner();
                    AdMob.removeBanner();

                    document.getElementById('leftSideMenu').style.visibility = "visible";
                    map.setClickable(false);
                    $ionicSideMenuDelegate.toggleLeft();
                }
            };
            $scope.showFilterDetail = function(){
                if(map != null){
                    map.setClickable(false);
                }
                $scope.showFilterStatus = false;
                $scope.modal.show();
            };
            $scope.countryFilter = false;
            $scope.showCountry = function(){
                if(map != null){
                    map.setClickable(false);
                }
                $scope.countryFilter = true;
            };
            $scope.hideCountry = function(){
                if(map != null){
                    map.setClickable(true);
                }
                $scope.countryFilter = false;
            };
            var utils = {
                //All List
                filterChallengeList : function(challengeList){
                    return $filter('multipleSearch')(challengeList,$scope.subCatForChallenge,$scope.tagForChallenge);
                },
                insertMarker:function(){

                    if (map != null){
                        if (addMarker.addMarkerList(map,$scope.challengeList)){
                            $timeout.cancel(time);
                        }
                    }
                },
                getChallengeList: function(inputs){
                    $scope.defaultMessage = "Sorry, Hungry Haven is currently not available in this city. Let us know  if you’d like to see challenges and contests here!";
                    var challList = dataService.getChallengeList(inputs);

                        if (challList.length != 'undefined' && challList.length >= 0){
                            $scope.originalChallengeList = challList;
                            $scope.challengeList = utils.filterChallengeList(challList);
                            utils.getSubCats();

                        }
                        else{

                            challList.then(function(response){
                                $scope.originalChallengeList = response;
                                $scope.challengeList = utils.filterChallengeList(response);
                                utils.getSubCats();

                            });
                        }
                        // $scope.challengeList = challList;




                    //return JSON.stringify(dataService.getChallengeList(inputs));
                },
                getChallengeOnly:function(){
                    $scope.defaultMessage = "No food challenges available at this time.";
                    $scope.challengeList = ChallengeList.getChallengeList();
                },
                getContestOnly:function(){
                    $scope.defaultMessage = "No food contests available at this time.";
                    $scope.challengeList = ChallengeList.getContestList();
                },
                getFestivalOnly:function(){
                    $scope.defaultMessage = "No food festivals available at this time.";
                    $scope.challengeList = ChallengeList.getFestivalList();
                },
                getTags:function(){
                    $scope.tagList = User.getTags();
                },
                getSubCats : function(){
                    /*SUB CATEGORY FUNCTION BEGINS*/
                    var subCatList = dataService.getSubCat();

                    if (subCatList.length >= 0){
                        $scope.originalSubCatList = subCatList;
                        $scope.subCatList = $filter('subcatSpecific')(subCatList,$scope.originalChallengeList,$scope.subCatForChallenge);

                    }else{
                        subCatList.then(function(response){
                            $scope.originalSubCatList = subCatList;
                            $scope.subCatList = $filter('subcatSpecific')(response,$scope.originalChallengeList,$scope.subCatForChallenge);
                        });
                    }


                },
                getSubCatForChallenge : function(){
                    var subCatForChallenge = dataService.getSubCatForChallenge();
                    if (typeof subCatForChallenge != 'undefined' && subCatForChallenge.length >=0){
                        $scope.subCatForChallenge = subCatForChallenge;
                    }else{
                        subCatForChallenge.then(function(response){
                            $scope.subCatForChallenge = response;
                        })
                    }
                },
            };
            function onSuccess(position) {
                /* alert('Latitude: '          + position.coords.latitude          + '\n' +
                 'Longitude: '         + position.coords.longitude         + '\n' +
                 'Altitude: '          + position.coords.altitude          + '\n' +
                 'Accuracy: '          + position.coords.accuracy          + '\n' +
                 'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
                 'Heading: '           + position.coords.heading           + '\n' +
                 'Speed: '             + position.coords.speed             + '\n' +
                 'Timestamp: '         + position.timestamp                + '\n');

                 */
                console.log("SUccess: "+ position.coords.longitude + " LAT: "+ position.coords.latitude);

                utils.getChallengeList({longitude:position.coords.longitude,latitude:position.coords.latitude});
            };
            function currentSuccess(position){
                var inp = {longitude:position.coords.longitude,latitude:position.coords.latitude};
                var newCountry = dataService.get_challenge_list_by_location(inp);
                newCountry.then(function(response){
                    $scope.originalChallengeList = response;
                    $scope.challengeList = utils.filterChallengeList(response);
                    utils.getSubCats();

                });
            }

            // onError Callback receives a PositionError object
            //
            function onError(error) {
                if (StorageService.get('current_user_city') !== null && StorageService.get('current_user_state') !== null
                    && StorageService.get('current_user_country') !== null){
                    console.log("Error: "+ StorageService.get('current_user_city'));
                    utils.getChallengeList({city:StorageService.get('current_user_city'),state:StorageService.get('current_user_state'),country:StorageService.get('current_user_country'),auth_token:""});
                }else{
                    utils.getChallengeList({longitude:0,latitude:0});
                }

            };
            var loggedIn = Auth.isLoggedIn();
            var init = function (){
                document.getElementById('leftSideMenu').style.visibility = "hidden";
                if (map != null){
                    map.setClickable(true);
                }
                var inputs = null;
                if (loggedIn !== null){
                    inputs = {auth_token:loggedIn.auth_token,category_type:''};
                    utils.getChallengeList(inputs);
                }else{
                    if ("geolocation" in navigator){
                        navigator.geolocation.getCurrentPosition(onSuccess, onError);
                    }

                }
                utils.getSubCatForChallenge();
                utils.getSubCats();
                $scope.admin = definedVariable.getAdminRootClean();
                $scope.filterList = definedVariable.getFilterList();

                $scope.isAndroid = /(android)/i.test(navigator.userAgent) ? true : false;
                // initAd();
               // createBanner();
               // console.log(utils.getChallengeList(''));
            }
            init();

            $scope.changeCity = function(city){
                $scope.hideCountry();
                User.refreshFilters();
                var auth;
                if (loggedIn != null){
                    auth = loggedIn.auth_token;
                }else{
                    auth = "";
                }
                if (city.group !== null && city.group != "Use Current Location"){

                    var newCountry = dataService.get_challenge_list_by_location({
                        loc_group : city.group
                    });
                    newCountry.then(function(response){
                        $scope.originalChallengeList = response;
                        $scope.challengeList = utils.filterChallengeList(response);
                        utils.getSubCats();


                    });
                    StorageService.set('current_user_city',city.city);
                    StorageService.set('current_user_state',city.state);
                    StorageService.set('current_user_country',city.country);
                    StorageService.set('loc_group',city.group);
                }
                else if (city !== null && city.state !== "" && city.country !== "" && city.city != "Use Current Location"){
                    var newCountry = dataService.get_challenge_list_by_location({
                        city:city.city,
                        state:city.state,
                        country:city.country,
                        auth_token:auth,
                        category_type:''
                    });
                    newCountry.then(function(response){
                        $scope.originalChallengeList = response;
                        $scope.challengeList = utils.filterChallengeList(response);
                        utils.getSubCats();

                    });
                    StorageService.set('current_user_city',city.city);
                    StorageService.set('current_user_state',city.state);
                    StorageService.set('current_user_country',city.country);


                }else{
                    if ("geolocation" in navigator){
                        navigator.geolocation.getCurrentPosition(currentSuccess, onError);
                    }
                }

            };


            //$scope.filterFunction = utils.filterTagFunction;
            $ionicModal.fromTemplateUrl('templates/sort.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                    $scope.modal = modal;
            });
            $scope.$on('challenge:updated', function(event,data) {
                // you could inspect the data to see if what you care about changed, or just update your own scope
                if (map != null){
                    if (addMarker.addMarkerList(map,data)){

                    }
                }
            });
            $scope.$watch('challengeList',function(newValue,oldValue){

                if (map != null && newValue !== oldValue){
                    if (addMarker.addMarkerList(map,newValue)){

                    }
                    else{
                        console.log("RETURN FALSE");
                    }
                }
            });
            $scope.$watch('originalChallengeList',function(newValue,oldValue){

            });
            $scope.$watch('subCatList',function(newValue,oldValue){

            });
           // $timeout(utils.insertMarker(),5000);
            //$scope.challengeList = utils.getChallengeList(inputs);
        });
    }])
    .controller('challengeListCtrl',['$scope','Auth','countryList','$stateParams','$ionicPlatform','$timeout','$ionicSideMenuDelegate','definedVariable','dataService',
        '$ionicModal','User','adMobHelper','ChallengeList','$ionicScrollDelegate','StorageService', '$filter',
        function($scope,Auth,countryList, $stateParams,$ionicPlatform,$timeout,$ionicSideMenuDelegate,definedVariable,dataService,$ionicModal,User,adMobHelper,ChallengeList,$ionicScrollDelegate,StorageService,$filter) {
        $ionicPlatform.ready(function() {

            window.scope = $scope;
            /*this section is for tag filter*/
            var AdMob;
            var createBanner = function(){
                if (window.AdMob ){
                    console.log("I AM IN HERE window plugin");
                    if (navigator.userAgent !== undefined){
                        var admobid = ( /(android)/i.test(navigator.userAgent) ) ? adMobHelper.getAndroid() : adMobHelper.getIos();
                    }else{
                        var admobid =oadMobHelper.getAndroid() ;
                    }

                    AdMob = window.AdMob;

                    AdMob.createBanner({
                            adId: admobid.banner,
                            position:AdMob.AD_POSITION.BOTTOM_CENTER,
                            overlap: true,
                            autoShow:true,
                            success:function(){console.log("Success Ad");},
                            error:function(){console.log("Error ad: ");}
                        });
                }
            };
            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Challenge List View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Challenge List View');
            }else{
                console.log("Analytics not set");
            }
            /**
             * Geolocation
             * @param position
             */
            function onSuccess(position) {
                /* alert('Latitude: '          + position.coords.latitude          + '\n' +
                 'Longitude: '         + position.coords.longitude         + '\n' +
                 'Altitude: '          + position.coords.altitude          + '\n' +
                 'Accuracy: '          + position.coords.accuracy          + '\n' +
                 'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
                 'Heading: '           + position.coords.heading           + '\n' +
                 'Speed: '             + position.coords.speed             + '\n' +
                 'Timestamp: '         + position.timestamp                + '\n');

                 */
                console.log("SUccess: "+ position.coords.longitude + " LAT: "+ position.coords.latitude);

                utils.getChallengeList({longitude:position.coords.longitude,latitude:position.coords.latitude});
            };

            // onError Callback receives a PositionError object
            //
            function onError(error) {
                if (StorageService.get('current_user_city') !== null && StorageService.get('current_user_state') !== null
                    && StorageService.get('current_user_country') !== null){
                    console.log("Error: "+ StorageService.get('current_user_city'));
                    utils.getChallengeList({city:StorageService.get('current_user_city'),state:StorageService.get('current_user_state'),country:StorageService.get('current_user_country'),auth_token:""});
                }else{
                    utils.getChallengeList({longitude:0,latitude:0});
                }

            };

            createBanner();


            /*Tag Filter Complete*/




            /*Sub Category Function Ends*/
            /*This is modal functions*/
            var modalOptions = {
                closeModal:function(){
                    $scope.modal.hide();
                },
                filterTags:function(tag){
                    User.setTagFilters(tag);
                    if (User.getSubCatFilters().length > 0 || User.getTagFilters().length > 0){
                        $scope.defaultMessage = "Sorry, there are no results that match your search.";
                    }
                },
                filterSubCat:function(subCat){
                    User.setSubCatFilters(subCat);
                    if (User.getSubCatFilters().length > 0 || User.getTagFilters().length > 0){
                        $scope.defaultMessage = "Sorry, there are no results that match your search.";
                    }
                    $scope.challengeList = utils.filterChallengeList($scope.originalChallengeList);

                },
                tagSelectClass:function(tag){
                    var styleClass= 'button button-light';
                    var tempFilteredTag = User.getTagFilters();
                    angular.forEach(tempFilteredTag,function(value,key){
                        if (tag.tag_id === value.tag_id){
                            styleClass =  'button button-assertive';
                            return;
                        }
                    });
                    return styleClass;
                },
                subCatSelectClass:function(tag){
                    var styleClass= 'button button-light';

                    var tempFilteredTag = User.getSubCatFilters();
                    angular.forEach(tempFilteredTag,function(value,key){

                        if (tag.sub_id === value.sub_id){

                            styleClass =  'button button-assertive';
                        }
                    });
                    return styleClass;
                }
            };
            $scope.modalActions = modalOptions;

            /*Modal function ends*/


            var list = countryList.setList();
            if (list.length !="undefined" && list.length >= 0){
                $scope.countryList = list;
                if ($scope.countryList[0].city != "Use Current Location"){
                    $scope.countryList.splice(0,0,{city:"Use Current Location",state:"",country:"Location",group:"Use Current Location"});
                }
                $scope.countryList = $filter('groupByCountry')($scope.countryList);

            }else{
                list.then(function(result){

                    $scope.countryList =  result.data;
                    if ($scope.countryList[0].city != "Use Current Location"){
                        $scope.countryList.splice(0,0,{city:"Use Current Location",state:"",country:"Location",group:"Use Current Location"});
                    }
                    $scope.countryList = $filter('groupByCountry')($scope.countryList);

                });
            }

            var loggedIn = Auth.isLoggedIn();
            $scope.defaultMessage ="";
            var utils = {
                //All List
                filterChallengeList : function(challengeList){
                    return $filter('multipleSearch')(challengeList,$scope.subCatForChallenge,$scope.tagForChallenge);
                },
                doRefresh : function(){
                    var auth;
                    if (loggedIn != null){
                        auth = loggedIn.auth_token;
                    }else{
                        auth = "";
                    }
                    ChallengeList.clearMemory();
                    User.refreshFilters();
                    utils.getTags();
                    utils.getSubCats();
                    if (StorageService.get('loc_group') !== null ){

                        var newCountry = dataService.get_challenge_list_by_location({
                            loc_group : StorageService.get('loc_group')
                        });
                        newCountry.then(function(response){

                            $scope.challengeList = response;

                        }).finally(function(){
                                $scope.$broadcast('scroll.refreshComplete');
                            });

                    }
                    else if (StorageService.get('current_user_city') !== null && StorageService.get('current_user_state') !== null &&
                        StorageService.get('current_user_country') !== null ){
                        var newCountry = dataService.get_challenge_list_by_location({
                            city:StorageService.get('current_user_city'),
                            state:StorageService.get('current_user_state'),
                            country:StorageService.get('current_user_country'),
                            auth_token:auth,
                            category_type:''
                        });
                        newCountry.then(function(response){
                            $scope.originalChallengeList = response;
                            $scope.challengeList = utils.filterChallengeList(response);


                        }).finally(function(){
                                $scope.$broadcast('scroll.refreshComplete');
                            });



                    }else if (loggedIn != null){
                        var inputs = {auth_token:auth,category_type:''};
                        utils.getChallengeList(inputs);
                    }else{
                        if ("geolocation" in navigator){


                            navigator.geolocation.getCurrentPosition(onSuccess, onError);
                        }
                    }

                },
                filterSubCat: function(){
                    return $filter('subcatSpecific')($scope.originalSubCatList,$scope.originalChallengeList,$scope.subCatForChallenge);
                },
                subCatListFiltered : function(){
                    $scope.subCatListFiltered = utils.filterSubCat();
                },
                getSubCats : function(){
                    /*SUB CATEGORY FUNCTION BEGINS*/
                    var subCatList = dataService.getSubCat();

                    if (subCatList.length >= 0){
                        $scope.originalSubCatList = subCatList;
                        $scope.subCatList = $filter('subcatSpecific')(subCatList,$scope.originalChallengeList,$scope.subCatForChallenge);

                    }else{
                        subCatList.then(function(response){
                            $scope.originalSubCatList = subCatList;
                            $scope.subCatList = $filter('subcatSpecific')(response,$scope.originalChallengeList,$scope.subCatForChallenge);
                        });
                    }


                },
                getSubCatForChallenge : function(){
                    var subCatForChallenge = dataService.getSubCatForChallenge();
                    if (typeof subCatForChallenge != 'undefined' && subCatForChallenge.length >=0){
                        $scope.subCatForChallenge = subCatForChallenge;
                    }else{
                        subCatForChallenge.then(function(response){
                            $scope.subCatForChallenge = response;
                        })
                    }
                },
                getTags : function(){
                    var taglist = dataService.getTags();
                    if (taglist.length >= 0){
                        $scope.tagList = taglist;
                    }else{
                        taglist.then(function(response){
                            $scope.tagList = response;
                        });
                    }
                    $scope.tagForChallenge = [];
                    var tagForChallenge = dataService.getTagForChallenge();
                    if (tagForChallenge.length >=0){
                        $scope.tagForChallenge = tagForChallenge;
                    }else{
                        tagForChallenge.then(function(response){
                            $scope.tagForChallenge = response;
                        });
                    }
                },
                getChallengeList: function(inputs){
                    $scope.defaultMessage = "Sorry, Hungry Haven is currently not available in this city. Let us know  if you’d like to see challenges and contests here!";
                    var challList = dataService.getChallengeList(inputs);


                    if (challList.length != 'undefined' && challList.length >= 0){
                        $scope.originalChallengeList = challList;
                        $scope.challengeList = utils.filterChallengeList(challList);
                        utils.getSubCats();
                        $scope.$broadcast('scroll.refreshComplete');

                    }
                    else{
                        //$scope.challengeList = challList;
                        challList.then(function(response){
                            $scope.originalChallengeList = response;
                            $scope.challengeList = utils.filterChallengeList(response);
                            utils.getSubCats();
                        }).finally(function(){

                                    // Stop the ion-refresher from spinning
                                    $scope.$broadcast('scroll.refreshComplete');
                        });

                    }
                    // $scope.challengeList = challList;


                    //return JSON.stringify(dataService.getChallengeList(inputs));
                },
                getChallengeOnly:function(){
                    $scope.defaultMessage = "No food challenges available at this time.";
                    $scope.challengeList = ChallengeList.getChallengeList();
                },
                getContestOnly:function(){
                    $scope.defaultMessage = "No food contests available at this time.";
                    $scope.challengeList = ChallengeList.getContestList();
                },
                getFestivalOnly:function(){
                    $scope.defaultMessage = "No food festivals available at this time.";
                    $scope.challengeList = ChallengeList.getFestivalList();
                }
            };
            var init = function (){
                document.getElementById('leftSideMenu').style.visibility = "hidden";

                if (loggedIn != null){
                    var inputs = {auth_token:loggedIn.auth_token,category_type:''};
                    utils.getChallengeList(inputs);
                }else{
                    if ("geolocation" in navigator){


                        navigator.geolocation.getCurrentPosition(onSuccess, onError);
                    }
                }
                utils.getSubCatForChallenge();
                utils.getTags();
                utils.getSubCats();

                $scope.admin = definedVariable.getAdminRootClean();
                $scope.filterList = definedVariable.getFilterList();

                $scope.isAndroid = /(android)/i.test(navigator.userAgent) ? true : false;
                $scope.doRefresh = utils.doRefresh;


                // console.log(utils.getChallengeList(''));
            }
            init();
            function currentSuccess(position){
                var inp = {longitude:position.coords.longitude,latitude:position.coords.latitude};
                var newCountry = dataService.get_challenge_list_by_location(inp);
                newCountry.then(function(response){
                    $scope.originalChallengeList = response;
                    $scope.challengeList = utils.filterChallengeList(response);
                    utils.getSubCats();
                });
            }
            $scope.changeCity = function(city){
                $scope.hideCountry();
                User.refreshFilters();
                var auth;
                if (loggedIn != null){
                    auth = loggedIn.auth_token;
                }else{
                    auth = "";
                }

                if (city.group !== null && city.group != "Use Current Location"){

                    var newCountry = dataService.get_challenge_list_by_location({
                        loc_group : city.group
                    });
                    newCountry.then(function(response){
                        $scope.originalChallengeList = response;
                        $scope.challengeList = utils.filterChallengeList(response);
                        utils.getSubCats();

                    });
                    StorageService.set('current_user_city',city.city);
                    StorageService.set('current_user_state',city.state);
                    StorageService.set('current_user_country',city.country);
                    StorageService.set('loc_group',city.group);
                }
                else if (city !== null && city.state !== "" && city.country !== "" && city.city != "Use Current Location"){
                    var newCountry = dataService.get_challenge_list_by_location({
                        city:city.city,
                        state:city.state,
                        country:city.country,
                        auth_token:auth,
                        category_type:''
                    });
                    newCountry.then(function(response){
                        $scope.originalChallengeList = response;
                        $scope.challengeList = utils.filterChallengeList(response);
                        utils.getSubCats();

                    });
                    StorageService.set('current_user_city',city.city);
                    StorageService.set('current_user_state',city.state);
                    StorageService.set('current_user_country',city.country);


                }else{
                    if ("geolocation" in navigator){
                        navigator.geolocation.getCurrentPosition(currentSuccess, onError);
                    }
                }


            };

            $scope.countryFilter = false;
            $scope.showCountry = function(){
                $scope.countryFilter = true;
            };
            $scope.hideCountry = function(){
                $scope.countryFilter = false;
            };
            $scope.showFilterDetail = function(){
                $scope.showFilterStatus = false;
                $scope.modal.show();
            };

            /*Basic Category Ends*/
            /**
             * This is where custom filter begins
             * @type {Array}
             */
            var lastSelection = 0;
            var preSetFilterView = false;
            var filterIconList = [
                {not_selected:"img/all-inactive@3x.png" , selected:"img/all-active@3x.png"},
                {not_selected:"img/challenges-inactive@3x.png" , selected:"img/challenges-active@3x.png"},
                {not_selected:"img/contests-inactive@3x.png" , selected:"img/contests-active@3x.png"},
                {not_selected:"img/festivals-inactive@3x.png", selected:"img/festivals-active@3x.png"},
                {not_selected:"img/more-inactive@3x.png", selected:"img/more-active@3x.png"}
            ];
            $scope.changeFilter = function(index){
                $scope.showFilterSelected = index;
                $scope.filSel = index;
                lastSelection = index;
                if (index == 0){
                    $scope.defaultMessage = "Sorry, Hungry Haven is currently not available in this city. Let us know  if you’d like to see challenges and contests here!";
                    $scope.challengeList = ChallengeList.getList();
                }else if (index == 1){
                    utils.getChallengeOnly();
                }else if (index == 2){
                    utils.getContestOnly();
                }else if (index == 3){
                    utils.getFestivalOnly();
                }
            };
            $scope.fTest = filterIconList;
            var delegate = $ionicScrollDelegate.$getByHandle('small');
            var scroll_position = 0;
            $scope.filSel = 0;

            var startAtX = 0;
            $scope.getXStart = function(){
                return startAtX;
            }
            $scope.clickFilter = function($index){
                if ($index == 4){
                    $scope.showFilterDetail();
                }else{
                    $scope.filSel = $index;
                    lastSelection = $index;
                    startAtX = (100*$index);
                    delegate.scrollTo(100*$scope.filSel,0,true);
                    $scope.changeFilter($index);
                    var time = $timeout(function() {
                        $scope.showFilterStatus = false;
                        return true;
                    }, 1000);
                }


            };

            $scope.showFilterStatus = false;
            $scope.showFilter = function(){

                //delegate.scrollTo(100*$scope.filSel, 0 , false);
                console.log("SCOPE FILE SEL "+$scope.filSel);
                if ($scope.showFilterStatus == false){
                    preSetFilterView = true;
                    $scope.showFilterStatus = true;
                    //delegate.scrollToRememberedPosition();

                    /*delegate.scrollTo(100*$scope.filSel, 0 , false);*/
                }
                else{
                    $scope.showFilterStatus = false;
                    preSetFilterView = false;

                    //$scope.clickFilter(sel);
                }
                console.log("SCOPE FILE SEL "+$scope.filSel);
            };

            $scope.testSwipe = function(){

                scroll_position = delegate.getScrollPosition().left;
                console.log("SCOPE SCROLL POSITION "+scroll_position);
                if (preSetFilterView){
                    delegate.scrollTo(100*lastSelection, 0 , true);
                    preSetFilterView = false;
                }
                else if (scroll_position < 60 && $scope.showFilterStatus == true){
                    $scope.filSel = 0;
                }else if (scroll_position >60 && scroll_position<140 && $scope.showFilterStatus == true){
                    $scope.filSel = 1;
                }else if (scroll_position > 140 && scroll_position < 240 && $scope.showFilterStatus == true){
                    $scope.filSel = 2;
                }else if (scroll_position > 240 && $scope.showFilterStatus == true){
                    $scope.filSel = 3;
                }

                /*else if (scroll_position > 240 && scroll_position < 340){
                 $scope.filSel = 3;
                 }else{
                 $scope.filSel = 4;
                 }*/
                if ($scope.filSel < 4 && $scope.showFilterStatus == true && lastSelection != $scope.filSel){
                    lastSelection = $scope.filSel;
                    startAtX = (100*$scope.filSel);
                    delegate.scrollTo(100*$scope.filSel, 0 , true);
                    $scope.changeFilter($scope.filSel);
                    //delegate.rememberScrollPosition('position-set');

                }else if ($scope.filSel == 4 && $scope.showFilterStatus == true && lastSelection != $scope.filSel){
                    lastSelection = $scope.filSel;
                    delegate.scrollTo(100*$scope.filSel, 0 , true);
                    var time = $timeout(function() {
                        $scope.showFilterDetail();
                        return true;
                    }, 1000);
                    //
                }
                console.log("SCOPE TEST SWIPE SELE" + $scope.filSel);
                // alert("INSIDE TEST SWIPE " + JSON.stringify(delegate.getScrollPosition()));

            };


            $ionicModal.fromTemplateUrl('templates/sort.html', {
                scope: $scope
            }).then(function(modal) {
                    $scope.modal = modal;
                });
            $scope.challengeAvailable = true;
            $scope.$on('challenge:updated', function(event,data) {

            });
            $scope.$watch('challengeList',function(newValue,oldValue){

            });
            $scope.$watch('originalChallengeList',function(newValue,oldValue){

            });
            $scope.$watch('countryList',function(newValue,oldValue){

            });
            $scope.$watch('subCatList',function(newValue,oldValue){

            });

            $scope.toggleSideMenu = function(){

                if ($ionicSideMenuDelegate.isOpenLeft()){
                    $scope.showFilterStatus = false;
                    createBanner();
                    document.getElementById('leftSideMenu').style.visibility = "hidden";
                    //map.setClickable(true);
                    $ionicSideMenuDelegate.toggleRight();
                }
                else{
                    $scope.showFilterStatus = false;
                    AdMob.removeBanner();
                    document.getElementById('leftSideMenu').style.visibility = "visible";
                    // map.setClickable(false);
                    $ionicSideMenuDelegate.toggleLeft();

                }

            };
        });
    }])
    .controller('festivalListCtrl',['$scope','$stateParams','$ionicPlatform','$timeout','$ionicSideMenuDelegate','ChallengeList' ,
        function($scope, $stateParams,$ionicPlatform,$timeout,$ionicSideMenuDelegate,ChallengeList) {
        $ionicPlatform.ready(function() {
            window.scope = $scope;
            $scope.toggleSideMenu = function(){

                if ($ionicSideMenuDelegate.isOpenLeft()){

                    document.getElementById('leftSideMenu').style.visibility = "hidden";
                    //map.setClickable(true);
                    $ionicSideMenuDelegate.toggleRight();
                }
                else{


                    document.getElementById('leftSideMenu').style.visibility = "visible";
                    //map.setClickable(false);
                    $ionicSideMenuDelegate.toggleLeft();

                }

            };
            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Festival List View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Festival List View');
            }else{
                console.log("Analytics not set");
            }
            var utils = {
                getFestival : function(){
                    $scope.festivalList = ChallengeList.getFestivalList();
                }
            };

            var init = function(){
                utils.getFestival();
            };
            init();
        });
    }])
    .controller('influencerListCtrl',['$scope','$stateParams','$ionicPlatform','$timeout','$ionicSideMenuDelegate','dataService','definedVariable','adMobHelper',
        function($scope, $stateParams,$ionicPlatform,$timeout,$ionicSideMenuDelegate,dataService,definedVariable,adMobHelper) {
        $ionicPlatform.ready(function() {
            window.scope = $scope;
            var AdMob;
            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Influencer List View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Influencer List View');
            }else{
                console.log("Analytics not set");
            }

            var createBanner = function(){
                if (window.AdMob ){
                    console.log("I AM IN HERE window plugin");
                    var admobid = ( /(android)/i.test(navigator.userAgent) ) ? adMobHelper.getAndroid() : adMobHelper.getIos();
                    AdMob = window.AdMob;

                    AdMob.createBanner({
                            adId: admobid.banner,
                            position:AdMob.AD_POSITION.BOTTOM_CENTER,
                            overlap: true,
                            autoShow:true
                        },
                        function(){console.log("Success Ad");},
                        function(error){console.log("Error ad: "+error);}
                    )
                }
            };

            createBanner();
            $scope.toggleSideMenu = function(){

                if ($ionicSideMenuDelegate.isOpenLeft()){
                    createBanner();
                    document.getElementById('leftSideMenu').style.visibility = "hidden";
                    //map.setClickable(true);
                    $ionicSideMenuDelegate.toggleRight();
                }
                else{
                    AdMob.removeBanner();
                    document.getElementById('leftSideMenu').style.visibility = "visible";
                    //map.setClickable(false);
                    $ionicSideMenuDelegate.toggleLeft();

                }

            };
            var influencerList = dataService.getInfluencers();
            if (influencerList.length >=0){
                $scope.influencerList = influencerList;
            }else{
                influencerList.then(function(response){
                    $scope.influencerList = response;
                });
            }
            var init = function(){
                $scope.admin = definedVariable.getAdminRootClean();
            };
            init();
        });
    }])
    .controller('influencerDetailsCtrl',['$scope','$stateParams','$ionicPlatform','$timeout','$ionicSideMenuDelegate','$ionicNavBarDelegate','dataService','definedVariable',
        function($scope, $stateParams,$ionicPlatform,$timeout,$ionicSideMenuDelegate,$ionicNavBarDelegate,dataService,definedVariable) {
        $ionicPlatform.ready(function() {
            window.scope = $scope;
            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Influencer Details View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Influencer Details View');
            }else{
                console.log("Analytics not set");
            }
            $scope.goBack = function(){
                $ionicNavBarDelegate.back();
            };
            $scope.openWebView = function(link,target){
                var ref = window.open(link, target, 'location=yes');
            };
            var index = $stateParams.id;
            var influencerList = dataService.getInfluencers();
            var influencer_id;
            if (influencerList.length >=0){
                $scope.influencers = influencerList[index];
                influencer_id = $scope.influencers.id;
            }else{
                influencerList.then(function(response){
                    $scope.influencers = response[index];
                    influencer_id = $scope.influencers.id;
                });
            }

            var influencer_video = dataService.getInfluencersVideoById(influencer_id);

            influencer_video.then(function(response){

               $scope.influencerVideo = response;
            });


            $scope.admin = definedVariable.getAdminRootClean();
            $scope.toggleSideMenu = function(){

                if ($ionicSideMenuDelegate.isOpenLeft()){

                    document.getElementById('leftSideMenu').style.visibility = "hidden";
                    //map.setClickable(true);
                    $ionicSideMenuDelegate.toggleRight();
                }
                else{


                    document.getElementById('leftSideMenu').style.visibility = "visible";
                    //map.setClickable(false);
                    $ionicSideMenuDelegate.toggleLeft();

                }

            };
        });
    }])
    .controller('aboutCtrl',['$scope','$stateParams','$ionicPlatform','$timeout','$ionicSideMenuDelegate','adMobHelper' ,
        function($scope, $stateParams,$ionicPlatform,$timeout,$ionicSideMenuDelegate,adMobHelper) {
        $ionicPlatform.ready(function() {
            window.scope = $scope;
            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('About Page View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('About Page View');
            }else{
                console.log("Analytics not set");
            }
            var AdMob;
            var createBanner = function(){
                if (window.AdMob ){
                    console.log("I AM IN HERE window plugin");
                    var admobid = ( /(android)/i.test(navigator.userAgent) ) ? adMobHelper.getAndroid() : adMobHelper.getIos();
                    AdMob = window.AdMob;

                    AdMob.createBanner({
                            adId: admobid.banner,
                            position:AdMob.AD_POSITION.BOTTOM_CENTER,
                            autoShow:true
                        },
                        function(){console.log("Success Ad");},
                        function(error){console.log("Error ad: "+error);}
                    )
                }
            };

            createBanner();
            $scope.toggleSideMenu = function(){

                if ($ionicSideMenuDelegate.isOpenLeft()){
                    createBanner();
                    document.getElementById('leftSideMenu').style.visibility = "hidden";
                    //map.setClickable(true);
                    $ionicSideMenuDelegate.toggleRight();
                }
                else{
                    AdMob.removeBanner();
                    document.getElementById('leftSideMenu').style.visibility = "visible";
                    //map.setClickable(false);
                    $ionicSideMenuDelegate.toggleLeft();

                }

            };
        });
    }])
    .controller('settingsCtrl',['$scope','$stateParams','$ionicPlatform','$timeout','$ionicSideMenuDelegate','$ionicModal','Auth' ,
        '$location','$ionicActionSheet','countryList','User','definedVariable','dataService','adMobHelper','ChallengeList','blogList','influencerList','$ionicPopup','$state',
        function($scope, $stateParams,$ionicPlatform,$timeout,$ionicSideMenuDelegate,$ionicModal,Auth,$location,$ionicActionSheet,countryList,User,
                 definedVariable,dataService,adMobHelper,ChallengeList,blogList,influencerList,$ionicPopup,$state) {
        $ionicPlatform.ready(function() {


            window.scope = $scope;
            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Settings Page View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Settings Page View');
            }else{
                console.log('Analytics not set');
            }
            var AdMob;
            var createBanner = function(){
                if (window.AdMob ){
                    console.log("I AM IN HERE window plugin");
                    var admobid = ( /(android)/i.test(navigator.userAgent) ) ? adMobHelper.getAndroid() : adMobHelper.getIos();
                    AdMob = window.AdMob;

                    AdMob.createBanner({
                            adId: admobid.banner,
                            position:AdMob.AD_POSITION.BOTTOM_CENTER,
                            overlap: true,
                            autoShow:true
                        },
                        function(){console.log("Success Ad");},
                        function(error){console.log("Error ad: "+error);}
                    )
                }
            };

            createBanner();
            $scope.updated = {};
            $scope.admin = definedVariable.getAdminRootClean();
            $scope.countryList = [];
            var image_updated = false;
            var list = countryList.setList();
            list.then(function(result){

                $scope.countryList =  result.data;
            });
            $scope.userData = {};
            var user = User.getUserInfo();
            if (user.length >= 0){
                $scope.userData = user[0];
            }else{
                user.then(function(result){
                   $scope.userData = result[0];
                });
            }

            var imageURI = null;
            var takePicture = function(){
                navigator.camera.getPicture(onSuccess, onFail, {
                    quality: 50,
                    destinationType: Camera.DestinationType.FILE_URI,
                    targetWidth:200,
                    targetHeight:200
                });
            };
            var chooseFromGallery = function(){
                navigator.camera.getPicture(onSuccess, onFail, {
                    quality: 50,
                    destinationType: Camera.DestinationType.FILE_URI,
                    sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                    targetWidth:200,
                    targetHeight:200

                });
            };
            function onSuccess(FILE_URI) {
                var image = document.getElementById('myImage');
                //image.src = "data:image/jpeg;base64," + imageData;
                image.src = FILE_URI;
                imageURI = FILE_URI;
                Auth.upload_profile_pic(imageURI);
                image_updated = true;
            }
            function onFail(message) {

            }
            var modalOptions = {
                showActions:function(){
                    $ionicActionSheet.show({
                        buttons: [
                            { text: 'Camera' },
                            { text: 'Gallery' }
                        ],

                        titleText: 'Upload Picture',
                        cancelText: 'Cancel',
                        cancel: function() {

                            // add cancel code..
                        },
                        buttonClicked: function(index) {
                            if (index == 0){
                                takePicture();
                            }
                            else if (index == 1){
                                chooseFromGallery();
                            }

                            return true;
                        }
                    });

                },
                updateUserAction:function(){
                    console.log(dataService.get_auth_token().auth_token);
                    var loggedIn = Auth.isLoggedIn();
                    $scope.updated.auth_token = loggedIn.auth_token;
                    if (Auth.getPicId() != null){
                        $scope.updated.pic_id = Auth.getPicId();
                    }

                    var p = Auth.update_user($scope.updated).then(function(result){

                       if (result){
                           var promise = User.refreshUserInfo().then(function(response){
                               return true;
                           });
                           if (promise && ChallengeList.clearMemory() && blogList.clearMemory() && influencerList.clearMemory()){
                               var alertPopup = $ionicPopup.alert({
                                   title: 'Success!',
                                   template: "Profile Updated"
                               });
                               alertPopup.then(function(res) {
                                   $scope.modal.hide();
                               });

                           }
                           //$scope.modal.hide();
                       }else{
                           var alertPopup = $ionicPopup.alert({
                               title: 'Error',
                               template: "Something went wrong"
                           });
                           alertPopup.then(function(res) {

                           });

                       }
                        return true;
                    });

                },
                updatePassword:function(){
                    var loggedIn = Auth.isLoggedIn();
                    $scope.updated.auth_token = loggedIn.auth_token;
                    if (typeof $scope.updated.password != 'undefined' && typeof $scope.updated.conf_pass != 'undefined'
                        && $scope.updated.password == $scope.updated.conf_pass){
                        Auth.changePassword($scope.updated).then(function(result){
                            if (result && ChallengeList.clearMemory() && blogList.clearMemory() && influencerList.clearMemory()){
                                var alertPopup = $ionicPopup.alert({
                                    title: 'Success!',
                                    template: "Password Updated"
                                });
                                alertPopup.then(function(res) {
                                    $scope.modal.hide();
                                });
                            }else{
                                var alertPopup = $ionicPopup.alert({
                                    title: 'Error',
                                    template: "Something went wrong"
                                });
                                alertPopup.then(function(res) {

                                });
                            }
                        });
                    }else{
                        var alertPopup = $ionicPopup.alert({
                            title: 'Error',
                            template: "Something went wrong"
                        });
                        alertPopup.then(function(res) {

                        });
                    }

                },
                locationChange: function (city){

                    $scope.updated.city = city.city;
                    $scope.updated.state = city.state;
                    $scope.updated.country = city.country;
                }
            };

            $scope.modalActions = modalOptions;

            $ionicModal.fromTemplateUrl('templates/editProfile.html', {
                scope: $scope
            }).then(function(modal) {
                $scope.modal = modal;
            });

            // Triggered in the login modal to close it
            $scope.closeLogin = function() {
                if (image_updated){
                    var promise = User.refreshUserInfo().then(function(response){
                        $scope.modal.hide();
                    });
                }else{
                    $scope.modal.hide();
                }
                createBanner()

            };
            var loggedIn = Auth.isLoggedIn();
            var showPopup = function(){
                var myPopup = $ionicPopup.show({
                    template: '',
                    title: 'Requires Login',
                    subTitle: 'Please login or register to access this feature',
                    scope: $scope,
                    buttons: [
                        { text: 'Cancel' },
                        {
                            text: '<b>Login</b>',
                            type: 'button-assertive',
                            onTap: function(e) {
                                ChallengeList.clearMemory();
                                User.emptyUser();
                                blogList.clearMemory();
                                influencerList.clearMemory();
                                AdMob.removeBanner();
                                $state.go('login');

                            }
                        }
                    ]
                });
                myPopup.then(function(res) {
                    console.log('Tapped!', res);
                });
            }
            var utils = {
                editUser:function(){
                    if (loggedIn != null){
                        $scope.updated = {};
                        console.log('here');
                        $scope.editSelected = "profile";
                        AdMob.removeBanner();
                        $scope.modal.show();
                    }else{
                        showPopup();
                    }

                },
                editPassword:function(){
                    if (loggedIn != null){
                        $scope.updated = {};
                        $scope.editSelected = "password";
                        AdMob.removeBanner();
                        $scope.modal.show();
                    }else{
                        showPopup();
                    }

                },
                logout:function(){
                    if (loggedIn != null){
                        if (Auth.logout() && User.emptyUser() && ChallengeList.clearMemory() && blogList.clearMemory() && influencerList.clearMemory()){
                            facebookConnectPlugin.logout(fbLoginSuccess , function(error){});
                            AdMob.removeBanner();
                            $location.path('/');
                        }
                    }else{
                        showPopup();
                    }


                },
                goTo:function(url){
                    AdMob.removeBanner();
                    $state.go(url);
                }

            };
            var fbLoginSuccess = function(){

            };
            $scope.editProfile = utils.editUser;
            $scope.editPassword = utils.editPassword;
            $scope.signout = utils.logout;
            $scope.goTo = utils.goTo;
            if (loggedIn != null){
                $scope.loggedIn = true;
            }else{
                $scope.loggedIn = false;
            }
            $scope.toggleSideMenu = function(){

                if ($ionicSideMenuDelegate.isOpenLeft()){
                    createBanner();
                    document.getElementById('leftSideMenu').style.visibility = "hidden";
                    //map.setClickable(true);
                    $ionicSideMenuDelegate.toggleRight();
                }
                else{
                    AdMob.removeBanner();
                    document.getElementById('leftSideMenu').style.visibility = "visible";
                    //map.setClickable(false);
                    $ionicSideMenuDelegate.toggleLeft();

                }

            };
            $scope.isAndroid = /(android)/i.test(navigator.userAgent) ? true : false;
        });
    }])
    .controller('blogListCtrl',['$scope','$stateParams','$ionicPlatform','$timeout','$ionicSideMenuDelegate','dataService','definedVariable','adMobHelper','blogList',
        function($scope, $stateParams,$ionicPlatform,$timeout,$ionicSideMenuDelegate,dataService,definedVariable,adMobHelper,blogList) {
        $ionicPlatform.ready(function() {
            window.scope = $scope;
            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Blog List View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Blog List View');
            }else{
                console.log('Analytics not set');
            }
            var AdMob;
            var createBanner = function(){
                if (window.AdMob ){
                    console.log("I AM IN HERE window plugin");
                    var admobid = ( /(android)/i.test(navigator.userAgent) ) ? adMobHelper.getAndroid() : adMobHelper.getIos();
                    AdMob = window.AdMob;

                    AdMob.createBanner({
                            adId: admobid.banner,
                            position:AdMob.AD_POSITION.BOTTOM_CENTER,
                            overlap: true,
                            autoShow:true
                        },
                        function(){console.log("Success Ad");},
                        function(error){console.log("Error ad: "+error);}
                    )
                }
            };

            createBanner();
            var subMenuList = [
                {subMenuName:"TOP STORIES"},
                {subMenuName:"CATEGORIES"}
            ];
            $scope.selected = 0;
            $scope.subMenuList = subMenuList;
            $scope.selectBlog = function(index){
                $scope.selected = index;
            }

            $scope.toggleSideMenu = function(){

                if ($ionicSideMenuDelegate.isOpenLeft()){
                    createBanner();
                    document.getElementById('leftSideMenu').style.visibility = "hidden";
                    //map.setClickable(true);
                    $ionicSideMenuDelegate.toggleRight();
                }
                else{
                    AdMob.removeBanner();
                    document.getElementById('leftSideMenu').style.visibility = "visible";
                    //map.setClickable(false);
                    $ionicSideMenuDelegate.toggleLeft();

                }

            };
            var utils = {
                doRefresh : function(){
                    blogList.clearMemory();
                    utils.getBlogList();
                },
                getBlogList : function(){
                    var blogList = dataService.getBlog();

                    if (blogList.length >=0){
                        $scope.blogList = blogList;
                    }else{
                        blogList.then(function(response){
                            $scope.blogList = response;
                        }).finally(function(){
                                $scope.$broadcast('scroll.refreshComplete');
                            });
                    }

                }
            }
            var init = function(){
                utils.getBlogList();
                $scope.admin = definedVariable.getAdminRootClean();
                $scope.doRefresh = utils.doRefresh;
            }
            init();


        });
    }])
    .controller('settingsDetailCtrl',['$scope','$stateParams','$ionicPlatform','$ionicNavBarDelegate',
        function($scope, $stateParams,$ionicPlatform,$ionicNavBarDelegate) {
        $ionicPlatform.ready(function() {
            window.scope = $scope;
            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Privacy Or Terms View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Privacy or Terms View');
            }else{
                console.log('Analytics not set');
            }
            $scope.goBack = function(){
                $ionicNavBarDelegate.back();
            };
            $scope.isAndroid = /(android)/i.test(navigator.userAgent) ? true : false;
            var type = $stateParams.type;
            var privacy = {title:"Privacy Policy",sub_title:"PRIVACY STATEMENT", type:"privacy"};
            var terms = {title:"Terms and conditions",sub_title:"Terms Hungry Haven", type:"terms"};
            var disclaimer = {title:"Disclaimers",sub_title:"Disclaimers", type:"disclaimers"};
            if (type == "privacy"){
                $scope.details = privacy;
            }else if (type == "terms"){
                $scope.details = terms;
            }else if (type == "disclaimers"){
                $scope.details = disclaimer;
            }
        });
    }])
    .controller('detailsCtrl',['$scope','$stateParams','$ionicPlatform','$timeout','$ionicNavBarDelegate','ChallengeList' ,'definedVariable','$ionicActionSheet','Auth','dataService',
        '$ionicPopup','User','$state','blogList','influencerList',
        function($scope, $stateParams,$ionicPlatform,$timeout,$ionicNavBarDelegate,ChallengeList,definedVariable,$ionicActionSheet,Auth,dataService,$ionicPopup,User,$state,blogList,influencerList) {
        $ionicPlatform.ready(function() {

            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Challenge Details View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Challenge Details View');
            }else{
                console.log('Analytics not set');
            }
            $scope.goBack = function(){
                $ionicNavBarDelegate.back();
            };

            var menuC = [
                {menuName:"DETAILS"},
                {menuName:"PRIZE"},
                {menuName:"STATS"}
                //{menuName:"MORE INFO"}
            ];
            var menuFest = [
                {menuName:"DETAILS"},
                {menuName:"MORE INFO"}
            ];
            var contest={
                titleClass : "hcontestgreen",
                dateClass : "conDateG",
                timeClass : "",
                addressClass : "conAdsG",
                priceClass : "conTag",
                mapClass : "mapIt4Green mapIt4contest",
                otherClass: "srhDirHead tRts conlftBrd",
                eventInfoIcon: "evtInfo5",
                eventInfoDistance: "evtInfo6",
                timeEnabled: "false",
                priceEnabled: "true",
                dateEnabled:    false
            };
            var challenge={
                titleClass : "hcongreen",
                dateClass : "othDateG",
                timeClass : "othalmG",
                addressClass : "othAdsG",
                priceClass : "pTag",
                mapClass : "mapIt4Green",
                otherClass: "srhDirHead tRts lftBrd",
                eventInfoIcon: "evtInfo3",
                eventInfoDistance: "evtInfo4",
                timeEnabled: "true",
                priceEnabled: "true",
                dateEnabled:    false
            };
            var festival={
                titleClass : "hcon",
                dateClass : "othDate",
                timeClass : "",
                addressClass : "othAds",
                priceClass : "",
                mapClass : "mapIt",
                otherClass: "srhDirHead tRts",
                eventInfoIcon: "evtInfo1",
                eventInfoDistance: "evtInfo2",
                timeEnabled: "false",
                priceEnabled: "false",
                dateEnabled:    true
            };

            if ($stateParams.type == "contest"){
                $scope.styleClass = contest;
                $scope.menus = menuC;
            }else if ($stateParams.type == "challenge"){
                $scope.styleClass = challenge;
                $scope.menus = menuC;
            }else{
                $scope.styleClass = festival;
                $scope.menus = menuFest;
            }
            $scope.isFavourite = false;
            var utils = {
                addFavourite : function(){
                    if (loggedIn != null){
                        $scope.isFavourite = true;
                        dataService.addFavourite({challenge_id:$scope.challengeList.id,auth_token:loggedIn.auth_token}).then(function(resp){
                            //$scope.isFavourite = true;
                        });
                    }else{
                        var myPopup = $ionicPopup.show({
                            template: '',
                            title: 'Requires Login',
                            subTitle: 'Please login or register to access this feature',
                            scope: $scope,
                            buttons: [
                                { text: 'Cancel' },
                                {
                                    text: '<b>Login</b>',
                                    type: 'button-assertive',
                                    onTap: function(e) {
                                        ChallengeList.clearMemory();
                                        User.emptyUser();
                                        blogList.clearMemory();
                                        influencerList.clearMemory();
                                        var AdMob;
                                        if (window.AdMob ){
                                            AdMob = window.AdMob;
                                            AdMob.removeBanner();
                                        }

                                        $state.go('login');

                                    }
                                }
                            ]
                        });
                        myPopup.then(function(res) {
                            console.log('Tapped!', res);
                        });
                    }


                },
                removeFavourite : function(){

                    var inputs = {auth_token:loggedIn.auth_token,challenge_id:$scope.challengeList.id};
                    var rmList = dataService.removeFavourite(inputs);
                    $scope.isFavourite = false;
                    rmList.then(function(response){
                        //$scope.isFavourite = false;
                    });

                },
                isChallengeFavourite:function(input){
                    dataService.isChallengeFavourite(input).then(function(resp){
                        $scope.isFavourite = resp;
                    });


                },
                getChallengeList: function(){
                    return ChallengeList.getCurrentList();

                    //return JSON.stringify(dataService.getChallengeList(inputs));
                },
                showActions:function(){
                    $ionicActionSheet.show({
                        buttons: [
                            { text: 'Camera' },
                            { text: 'Gallery' }
                        ],

                        titleText: 'Upload Picture',
                        cancelText: 'Cancel',
                        cancel: function() {

                            // add cancel code..
                        },
                        buttonClicked: function(index) {
                            if (index == 0){
                                takePicture();
                            }
                            else if (index == 1){
                                chooseFromGallery();
                            }

                            return true;
                        }
                    });

                }
            };
                $scope.challengeList = null;
            var list = null;
            var loggedIn = Auth.isLoggedIn();
            var init = function (){
                list = utils.getChallengeList();

                console.log("CURRENT LIST: "+JSON.stringify(list));
                $scope.challengeList = list[$stateParams.id];
                $scope.selectedDetails = list[$stateParams.id].detail;
                $scope.selectedCategory = list[$stateParams.id].category_name;
                $scope.admin = definedVariable.getAdminRootClean();
                $scope.currentChallengeIndex = $stateParams.id;
                $scope.challenges = list;
                $scope.isAndroid = /(android)/i.test(navigator.userAgent) ? true : false;
                if (loggedIn != null){
                    utils.isChallengeFavourite({challenge_id:$scope.challengeList.id,auth_token:loggedIn.auth_token});
                }

                $scope.addFavourite = utils.addFavourite;
                $scope.removeFavourite = utils.removeFavourite;
                // console.log(utils.getChallengeList(''));
            };
            init();
            $scope.share = function(){
                var pic = null;
                var url = "http://www.hungryhaven.com/#/detail/0/"+list[$stateParams.id].id+"/"+list[$stateParams.id].category_name;
                var message = list[$stateParams.id].challenge_name + "\n" + list[$stateParams.id].short_detail+"\n";
                window.plugins.socialsharing.available(function(isAvailable) {
                    if (isAvailable) {
                        // use a local image from inside the www folder:
//      window.plugins.socialsharing.share('Some text', 'Some subject', null, 'http://www.nu.nl');
//      window.plugins.socialsharing.share('Some text');
                        if (list[$stateParams.id].pic_url != null){
                            pic = definedVariable.getAdminRootClean() + list[$stateParams.id].pic_url;
                        }

//      window.plugins.socialsharing.share('test', null, 'data:image/png;base64,R0lGODlhDAAMALMBAP8AAP///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAUKAAEALAAAAAAMAAwAQAQZMMhJK7iY4p3nlZ8XgmNlnibXdVqolmhcRQA7', null, function(e){alert("success: " + e)}, function(e){alert("error: " + e)});
                        window.plugins.socialsharing.share(message, 'Check out this Hungry Haven challenge!', pic, url, null, null);
                        // alternative usage:

                        // 1) a local image from anywhere else (if permitted):
                        // window.plugins.socialsharing.share('Some text', 'http://domain.com', '/Users/username/Library/Application Support/iPhone/6.1/Applications/25A1E7CF-079F-438D-823B-55C6F8CD2DC0/Documents/.nl.x-services.appname/pics/img.jpg');

                        // 2) an image from the internet:
//      window.plugins.socialsharing.share('Some text', "Some subject', 'http://domain.com', 'http://domain.com/image.jpg');

                        // 3) text and link:
//      window.plugins.socialsharing.share('Some text and a link', '', '', 'http://www.nu.nl');
                    }
                });
            };
            $scope.selected = 0;
            $scope.selectMenu = function(index){
                $scope.selected = index;
                if (menuC[index].menuName == "DETAILS"){
                    $scope.selectedDetails = list[$stateParams.id].detail;
                }else if (menuC[index].menuName == "PRIZE"){

                    $scope.selectedDetails = list[$stateParams.id].prize_details;
                }else if (menuC[index].menuName == "STATS"){


                    if (list[$stateParams.id].success_text === "" || list[$stateParams.id].success_text === null || list[$stateParams.id].success_text === 'null'){
                        $scope.selectedDetails = "No stats available. Yet.";


                    }else{
                        $scope.selectedDetails = "<ul><li>Successes: "+list[$stateParams.id].success_counter+"</li><li>Failures:"+list[$stateParams.id].failure_counter+"</li><li>"+list[$stateParams.id].success_text+"</li>";
                        if (list[$stateParams.id].stat_details === "null" || list[$stateParams.id].stat_details === "" || list[$stateParams.id].stat_details === null){
                            $scope.selectedDetails += "</ul>";
                        }else{
                            $scope.selectedDetails += "<li>"+list[$stateParams.id].stat_details+"</li></ul>";
                        }
                    }
                }else if (menuC[index].menuName == "MORE INFO"){
                    $scope.selectedDetails = list[$stateParams.id].detail;

                }
                //$scope.$apply();
            };

            $scope.$watch('selectedDetails',function(newValue,oldValue){

            });
            /*$scope.toggleRight = function() {
             alert('RightMenu');
             $ionicSideMenuDelegate.toggleRight();
             };
             $timeout(function() {
             var div = document.getElementById("mapView");
             map = plugin.google.maps.Map.getMap(div);
             }, 1000);

             $scope.toggleSideMenu = function(){

             if ($ionicSideMenuDelegate.isOpenLeft()){

             document.getElementById('leftSideMenu').style.visibility = "hidden";
             map.setClickable(true);
             $ionicSideMenuDelegate.toggleRight();
             }
             else{


             document.getElementById('leftSideMenu').style.visibility = "visible";
             map.setClickable(false);
             $ionicSideMenuDelegate.toggleLeft();

             }

             };*/

        });
    }])
    .controller('blogDetailsCtrl',['$scope','$stateParams','$ionicPlatform','$timeout','$ionicNavBarDelegate','dataService','definedVariable','$sanitize','$sce',
        function($scope, $stateParams,$ionicPlatform,$timeout,$ionicNavBarDelegate,dataService,definedVariable,$sanitize,$sce) {
            $ionicPlatform.ready(function() {
                window.scope = $scope;
                if (typeof window.analytics !== 'undefined'){
                    window.analytics.trackView('Blog Details View');
                }else if (typeof analytics !== 'undefined'){
                    analytics.trackView('Blog Details View');
                }else{
                    console.log('Analytics not set');
                }

                $scope.blogId = $stateParams.id;

                $scope.goBack = function(){
                    $ionicNavBarDelegate.back();
                };
                /*$scope.toggleSideMenu = function(){

                    if ($ionicSideMenuDelegate.isOpenLeft()){

                        document.getElementById('leftSideMenu').style.visibility = "hidden";
                        //map.setClickable(true);
                        $ionicSideMenuDelegate.toggleRight();
                    }
                    else{


                        document.getElementById('leftSideMenu').style.visibility = "visible";
                        //map.setClickable(false);
                        $ionicSideMenuDelegate.toggleLeft();

                    }

                };*/
                $scope.share = function(){
                    var pic = null;
                    var url = "http://www.hungryhaven.com/#/news/0/"+$scope.blogId;
                    var message = $scope.blogList.blog_title ;
                    window.plugins.socialsharing.available(function(isAvailable) {
                        if (isAvailable) {
                            // use a local image from inside the www folder:
//      window.plugins.socialsharing.share('Some text', 'Some subject', null, 'http://www.nu.nl');
//      window.plugins.socialsharing.share('Some text');
                            if ($scope.blogList.pic_url != null){
                                pic = definedVariable.getAdminRootClean() + $scope.blogList.pic_url;
                            }

//      window.plugins.socialsharing.share('test', null, 'data:image/png;base64,R0lGODlhDAAMALMBAP8AAP///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAUKAAEALAAAAAAMAAwAQAQZMMhJK7iY4p3nlZ8XgmNlnibXdVqolmhcRQA7', null, function(e){alert("success: " + e)}, function(e){alert("error: " + e)});
                            window.plugins.socialsharing.share(message,'Check out this Hungry Haven News!', pic, url, null, null);
                            // alternative usage:

                            // 1) a local image from anywhere else (if permitted):
                            // window.plugins.socialsharing.share('Some text', 'http://domain.com', '/Users/username/Library/Application Support/iPhone/6.1/Applications/25A1E7CF-079F-438D-823B-55C6F8CD2DC0/Documents/.nl.x-services.appname/pics/img.jpg');

                            // 2) an image from the internet:
//      window.plugins.socialsharing.share('Some text', "Some subject', 'http://domain.com', 'http://domain.com/image.jpg');

                            // 3) text and link:
//      window.plugins.socialsharing.share('Some text and a link', '', '', 'http://www.nu.nl');
                        }else{
                            console.log("Not available");
                        }
                    });
                };
                var utils = {
                    getBlogList : function(){
                        var blogList = dataService.getBlog();

                        if (blogList.length >=0){
                            $scope.blogList = blogList[$scope.blogId];
                            $scope.blogRelated = blogList;
                        }else{
                            blogList.then(function(response){
                                $scope.blogList = response[$scope.blogId];
                                $scope.blogRelated = response;

                            });
                        }

                    }
                }
                var init = function(){
                    utils.getBlogList();
                    $scope.admin = definedVariable.getAdminRootClean();
                    $scope.isAndroid = /(android)/i.test(navigator.userAgent) ? true : false;
                }
                init();


            });
        }])
    .controller('feedbackCtrl', function($scope,$ionicPlatform,$ionicNavBarDelegate,Auth,dataService,$ionicPopup,User,ChallengeList,$state,blogList,influencerList) {
        $ionicPlatform.ready(function() {
            document.getElementById('leftSideMenu').style.visibility = "hidden";
            var loggedIn = Auth.isLoggedIn();
            var auth_token = null;
            if (loggedIn != null){
                $scope.loggedIn = true;
                auth_token = loggedIn.auth_token;
            }else{
                $scope.loggedIn = false;
            }

            if (typeof window.analytics !== 'undefined'){
                window.analytics.trackView('Feedback View');
            }else if (typeof analytics !== 'undefined'){
                analytics.trackView('Feedback View');
            }else{
                console.log('Analytics not set');
            }
            $scope.goBack = function(){
                $ionicNavBarDelegate.back();
            };
            /*Model for feedback*/
            $scope.form_input = {};

            /*form submission with auth_token*/
            $scope.submit_feedback = function(){
                $scope.form_input.auth_token = auth_token;
                var promise = dataService.send_feedback($scope.form_input).then(function(response){
                    if (response.status == "success"){
                        var alertPopup = $ionicPopup.alert({
                            title: 'Success!',
                            template: "Thank you for your response"
                        });
                        alertPopup.then(function(res) {
                            $ionicNavBarDelegate.back();
                        });

                    }
                });

            };
            $scope.goLogin = function(){
                User.emptyUser();
                ChallengeList.clearMemory();
                blogList.clearMemory();
                influencerList.clearMemory();
                var AdMob;
                if (window.AdMob ){
                    AdMob = window.AdMob;
                    AdMob.removeBanner();
                }
                $state.go('login');
            };
            $scope.isAndroid = /(android)/i.test(navigator.userAgent) ? true : false;


        });
    })
    .controller('favouriteCtrl', ['$scope','Auth','countryList','$stateParams','$ionicPlatform','$timeout','$ionicSideMenuDelegate','definedVariable','dataService',
        '$ionicModal','User','adMobHelper','ChallengeList','$ionicScrollDelegate','StorageService','$ionicLoading','$state','blogList','influencerList',
        function($scope,Auth,countryList, $stateParams,$ionicPlatform,$timeout,$ionicSideMenuDelegate,definedVariable,dataService,$ionicModal,
                 User,adMobHelper,ChallengeList,$ionicScrollDelegate,StorageService,$ionicLoading,$state,blogList,influencerList) {
            $ionicPlatform.ready(function() {
                window.scope = $scope;
                /*this section is for tag filter*/
                if (typeof window.analytics !== 'undefined'){
                    window.analytics.trackView('Favourite View');
                }else if (typeof analytics !== 'undefined'){
                    analytics.trackView('Favourite View');
                }else{
                    console.log('Analytics not set');
                }
                var AdMob;
                var createBanner = function(){
                    if (window.AdMob ){
                        console.log("I AM IN HERE window plugin");
                        if (navigator.userAgent !== undefined){
                            var admobid = ( /(android)/i.test(navigator.userAgent) ) ? adMobHelper.getAndroid() : adMobHelper.getIos();
                        }else{
                            var admobid =oadMobHelper.getAndroid() ;
                        }

                        AdMob = window.AdMob;

                        AdMob.createBanner({
                            adId: admobid.banner,
                            position:AdMob.AD_POSITION.BOTTOM_CENTER,
                            overlap: true,
                            autoShow:true,
                            success:function(){console.log("Success Ad");},
                            error:function(){console.log("Error ad: ");}
                        });
                    }
                };
                createBanner();
                var loggedIn = Auth.isLoggedIn();
                var utils = {
                    getFavouriteList : function(inputs){
                        $ionicLoading.show({
                            template: '<i class=""></i>Loading...'
                        });
                        $scope.defaultMessage = "You don't have anything added to your list. <br />Browse around challenges and tap the star to save them for later!";
                        var challList = dataService.getFavouriteList(inputs);

                            //$scope.challengeList = challList;
                        challList.then(function(response){
                            console.log("RETURN : "+JSON.stringify(response));
                            $scope.challengeList = response;
                            $ionicLoading.hide();
                        });

                    },
                    removeFavourite : function(index){
                        var challenge_id = $scope.challengeList[index].id;
                        var inputs = {auth_token:loggedIn.auth_token,challenge_id:challenge_id};
                        var rmList = dataService.removeFavourite(inputs);
                        rmList.then(function(response){
                           console.log("Removed");
                        });
                        $scope.challengeList.splice(index, 1);
                    },
                    goLogin:function(){
                        User.emptyUser();
                        ChallengeList.clearMemory();
                        blogList.clearMemory();
                        influencerList.clearMemory();
                        $state.go('login');
                    }
                };

                var init = function(){

                    if (loggedIn != null){
                        $scope.loggedIn = true;
                        var inputs = {auth_token:loggedIn.auth_token};
                        $scope.admin = definedVariable.getAdminRootClean();
                        utils.getFavouriteList(inputs);
                        $scope.removeFavourite = utils.removeFavourite;
                    }else{
                        $scope.loggedIn = false;
                        $scope.goLogin = utils.goLogin;
                    }

                };
                init();
                $scope.toggleSideMenu = function(){

                    if ($ionicSideMenuDelegate.isOpenLeft()){

                        createBanner();
                        document.getElementById('leftSideMenu').style.visibility = "hidden";
                        //map.setClickable(true);
                        $ionicSideMenuDelegate.toggleRight();
                    }
                    else{

                        AdMob.removeBanner();
                        document.getElementById('leftSideMenu').style.visibility = "visible";
                        // map.setClickable(false);
                        $ionicSideMenuDelegate.toggleLeft();

                    }

                };
            });
        }])
    .controller('challengeDetailsCtrl',['$scope','$stateParams','$ionicPlatform','$timeout','$ionicNavBarDelegate','ChallengeList' ,'definedVariable','$ionicActionSheet','Auth','dataService','$ionicLoading',
        function($scope, $stateParams,$ionicPlatform,$timeout,$ionicNavBarDelegate,ChallengeList,definedVariable,$ionicActionSheet,Auth,dataService,$ionicLoading) {
            $ionicPlatform.ready(function() {

                if (typeof window.analytics !== 'undefined'){
                    window.analytics.trackView('Favourite Details View');
                }else if (typeof analytics !== 'undefined'){
                    analytics.trackView('Favourite Details View');
                }else{
                    console.log('Analytics not set');
                }
                $scope.goBack = function(){
                    $ionicNavBarDelegate.back();
                };

                var menuC = [
                    {menuName:"DETAILS"},
                    {menuName:"PRIZE"},
                    {menuName:"STATS"}
                    //{menuName:"MORE INFO"}
                ];
                var menuFest = [
                    {menuName:"DETAILS"},
                    {menuName:"MORE INFO"}
                ];
                var contest={
                    titleClass : "hcontestgreen",
                    dateClass : "conDateG",
                    timeClass : "",
                    addressClass : "conAdsG",
                    priceClass : "conTag",
                    mapClass : "mapIt4Green mapIt4contest",
                    otherClass: "srhDirHead tRts conlftBrd",
                    eventInfoIcon: "evtInfo5",
                    eventInfoDistance: "evtInfo6",
                    timeEnabled: "false",
                    priceEnabled: "true",
                    dateEnabled:    false
                };
                var challenge={
                    titleClass : "hcongreen",
                    dateClass : "othDateG",
                    timeClass : "othalmG",
                    addressClass : "othAdsG",
                    priceClass : "pTag",
                    mapClass : "mapIt4Green",
                    otherClass: "srhDirHead tRts lftBrd",
                    eventInfoIcon: "evtInfo3",
                    eventInfoDistance: "evtInfo4",
                    timeEnabled: "true",
                    priceEnabled: "true",
                    dateEnabled:    false
                };
                var festival={
                    titleClass : "hcon",
                    dateClass : "othDate",
                    timeClass : "",
                    addressClass : "othAds",
                    priceClass : "",
                    mapClass : "mapIt",
                    otherClass: "srhDirHead tRts",
                    eventInfoIcon: "evtInfo1",
                    eventInfoDistance: "evtInfo2",
                    timeEnabled: "false",
                    priceEnabled: "false",
                    dateEnabled:    true
                };

                if ($stateParams.type == "contest"){
                    $scope.styleClass = contest;
                    $scope.menus = menuC;
                }else if ($stateParams.type == "challenge"){
                    $scope.styleClass = challenge;
                    $scope.menus = menuC;
                }else{
                    $scope.styleClass = festival;
                    $scope.menus = menuFest;
                }
                //$scope.isFavourite = true;
                $scope.challengeList = null;
                var list = null;
                var loggedIn = Auth.isLoggedIn();
                var utils = {
                    addFavourite : function(){

                        dataService.addFavourite({challenge_id:$scope.challengeList.id,auth_token:loggedIn.auth_token}).then(function(resp){
                            $scope.isFavourite = true;
                        });

                    },
                    removeFavourite : function(){

                        var inputs = {auth_token:loggedIn.auth_token,challenge_id:$scope.challengeList.id};
                        var rmList = dataService.removeFavourite(inputs);
                        rmList.then(function(response){
                            $scope.isFavourite = false;
                        });

                    },
                    isChallengeFavourite:function(input){
                       dataService.isChallengeFavourite(input).then(function(resp){
                            $scope.isFavourite = resp;
                        });


                    },
                    getChallengeList: function(){
                        $ionicLoading.show({
                            template: '<i class=""></i>Loading...'
                        });
                            var chall = dataService.getChallangeById({challenge_id:$stateParams.id});
                            chall.then(function(response){
                                console.log("CHALLENGE : " + JSON.stringify(response));
                                $scope.challengeList = response[0];
                                $scope.selectedDetails = $scope.challengeList.detail;
                                $scope.selectedCategory = $scope.challengeList.category_name;
                                $ionicLoading.hide();
                                utils.isChallengeFavourite({challenge_id:$scope.challengeList.id,auth_token:loggedIn.auth_token});
                            });
                        //return JSON.stringify(dataService.getChallengeList(inputs));
                    },
                    showActions:function(){
                        $ionicActionSheet.show({
                            buttons: [
                                { text: 'Camera' },
                                { text: 'Gallery' }
                            ],
                            titleText: 'Upload Picture',
                            cancelText: 'Cancel',
                            cancel: function() {
                                // add cancel code..
                            },
                            buttonClicked: function(index) {
                                if (index == 0){
                                    takePicture();
                                }
                                else if (index == 1){
                                    chooseFromGallery();
                                }

                                return true;
                            }
                        });

                    }
                };


                var init = function (){
                    utils.getChallengeList();
                    //list = $scope.challengeList;
                    console.log("I am here");
                    console.log("LIST "+JSON.stringify($scope.challengeList));
                    //$scope.challengeList = list[0];

                    $scope.admin = definedVariable.getAdminRootClean();
                    $scope.currentChallengeIndex = 0;
                    $scope.challenges = list;
                    $scope.isAndroid = /(android)/i.test(navigator.userAgent) ? true : false;

                    $scope.addFavourite = utils.addFavourite;
                    $scope.removeFavourite = utils.removeFavourite;
                    // console.log(utils.getChallengeList(''));
                };
                init();
                $scope.share = function(){

                    var pic = null;
                    var url = "http://www.hungryhaven.com";
                    var message = $scope.challengeList.challenge_name + "\n" + $scope.challengeList.short_detail+"\n";
                    window.plugins.socialsharing.available(function(isAvailable) {
                        if (isAvailable) {
                            // use a local image from inside the www folder:
//      window.plugins.socialsharing.share('Some text', 'Some subject', null, 'http://www.nu.nl');
//      window.plugins.socialsharing.share('Some text');
                            if ($scope.challengeList.pic_url != null){
                                pic = definedVariable.getAdminRootClean() + $scope.challengeList.pic_url;
                            }

//      window.plugins.socialsharing.share('test', null, 'data:image/png;base64,R0lGODlhDAAMALMBAP8AAP///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAUKAAEALAAAAAAMAAwAQAQZMMhJK7iY4p3nlZ8XgmNlnibXdVqolmhcRQA7', null, function(e){alert("success: " + e)}, function(e){alert("error: " + e)});
                            window.plugins.socialsharing.share(message, 'Check out this Hungry Haven challenge!', pic, url, null, null);
                            // alternative usage:

                            // 1) a local image from anywhere else (if permitted):
                            // window.plugins.socialsharing.share('Some text', 'http://domain.com', '/Users/username/Library/Application Support/iPhone/6.1/Applications/25A1E7CF-079F-438D-823B-55C6F8CD2DC0/Documents/.nl.x-services.appname/pics/img.jpg');

                            // 2) an image from the internet:
//      window.plugins.socialsharing.share('Some text', "Some subject', 'http://domain.com', 'http://domain.com/image.jpg');

                            // 3) text and link:
//      window.plugins.socialsharing.share('Some text and a link', '', '', 'http://www.nu.nl');
                        }else{
                            console.log("Not Available");
                        }
                    });
                };
                $scope.selected = 0;
                $scope.selectMenu = function(index){
                    $scope.selected = index;
                    if (menuC[index].menuName == "DETAILS"){
                        $scope.selectedDetails = $scope.challengeList.detail;
                    }else if (menuC[index].menuName == "PRIZE"){

                        $scope.selectedDetails =  $scope.challengeList.prize_details;
                    }else if (menuC[index].menuName == "STATS"){


                        if ( $scope.challengeList.success_text != "" &&  $scope.challengeList.success_text != null &&  $scope.challengeList.success_text != "null")
                            $scope.selectedDetails =  $scope.challengeList.success_text;
                        else{
                            $scope.selectedDetails = "No stats available. Yet.";
                        }
                    }else if (menuC[index].menuName == "MORE INFO"){
                        $scope.selectedDetails =  $scope.challengeList.detail;

                    }
                    //$scope.$apply();
                };

                $scope.$watch('selectedDetails',function(newValue,oldValue){

                });

                /*$scope.toggleRight = function() {
                 alert('RightMenu');
                 $ionicSideMenuDelegate.toggleRight();
                 };
                 $timeout(function() {
                 var div = document.getElementById("mapView");
                 map = plugin.google.maps.Map.getMap(div);
                 }, 1000);

                 $scope.toggleSideMenu = function(){

                 if ($ionicSideMenuDelegate.isOpenLeft()){

                 document.getElementById('leftSideMenu').style.visibility = "hidden";
                 map.setClickable(true);
                 $ionicSideMenuDelegate.toggleRight();
                 }
                 else{


                 document.getElementById('leftSideMenu').style.visibility = "visible";
                 map.setClickable(false);
                 $ionicSideMenuDelegate.toggleLeft();

                 }

                 };*/

            });
        }])

    .controller('dealsCtrl',['$scope','Auth','countryList','$stateParams','$ionicPlatform','$timeout','$ionicSideMenuDelegate','definedVariable','dataService',
        '$ionicModal','User','adMobHelper','ChallengeList','$ionicScrollDelegate','StorageService','$ionicLoading',
        function($scope,Auth,countryList, $stateParams,$ionicPlatform,$timeout,$ionicSideMenuDelegate,definedVariable,dataService,
                 $ionicModal,User,adMobHelper,ChallengeList,$ionicScrollDelegate,StorageService,$ionicLoading) {
            $ionicPlatform.ready(function() {

                window.scope = $scope;
                if (typeof window.analytics !== 'undefined'){
                    window.analytics.trackView('Deals View');
                }else if (typeof analytics !== 'undefined'){
                    analytics.trackView('Deals View');
                }else{
                    console.log('Analytics not set');
                }
                /*this section is for tag filter*/
                var AdMob;
                var createBanner = function(){
                    if (window.AdMob ){
                        console.log("I AM IN HERE window plugin");
                        if (navigator.userAgent !== undefined){
                            var admobid = ( /(android)/i.test(navigator.userAgent) ) ? adMobHelper.getAndroid() : adMobHelper.getIos();
                        }else{
                            var admobid =oadMobHelper.getAndroid() ;
                        }

                        AdMob = window.AdMob;

                        AdMob.createBanner({
                            adId: admobid.banner,
                            position:AdMob.AD_POSITION.BOTTOM_CENTER,
                            overlap: true,
                            autoShow:true,
                            success:function(){console.log("Success Ad");},
                            error:function(){console.log("Error ad: ");}
                        });
                    }
                };

                /**
                 * Geolocation
                 * @param position
                 */
                function onSuccess(position) {
                    /* alert('Latitude: '          + position.coords.latitude          + '\n' +
                     'Longitude: '         + position.coords.longitude         + '\n' +
                     'Altitude: '          + position.coords.altitude          + '\n' +
                     'Accuracy: '          + position.coords.accuracy          + '\n' +
                     'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
                     'Heading: '           + position.coords.heading           + '\n' +
                     'Speed: '             + position.coords.speed             + '\n' +
                     'Timestamp: '         + position.timestamp                + '\n');

                     */
                    console.log("SUccess: "+ position.coords.longitude + " LAT: "+ position.coords.latitude);

                    utils.getDeals({lng:position.coords.longitude,lat:position.coords.latitude});
                };

                // onError Callback receives a PositionError object
                //
                function onError(error) {

                    utils.getDeals({city:"Toronto"});


                };

                createBanner();

                $scope.openWebView = function(link,target){
                    var ref = window.open(link, target, 'location=yes');
                };

                /*Modal function ends*/


                var list = countryList.setList();
                if (list.length !="undefined" && list.length >= 0){
                    $scope.countryList = list;
                    if ($scope.countryList[0].city != "Use Current Location"){
                        $scope.countryList.splice(0,0,{city:"Use Current Location",state:"",country:"Location",group:"Use Current Location"});
                    }
                    $scope.countryList = $filter('groupByCountry')($scope.countryList);

                }else{
                    list.then(function(result){

                        $scope.countryList =  result.data;
                        if ($scope.countryList[0].city != "Use Current Location"){
                            $scope.countryList.splice(0,0,{city:"Use Current Location",state:"",country:"Location",group:"Use Current Location"});
                        }
                        $scope.countryList = $filter('groupByCountry')($scope.countryList);

                    });
                }

                var loggedIn = Auth.isLoggedIn();
                $scope.defaultMessage ="";
                var utils = {
                    //All List
                    getDeals : function(input){
                        $ionicLoading.show({
                            template: '<i class=""></i>Loading...'
                        });
                        $scope.defaultMessage = "Finding your Hungry Deals";

                        var deals = dataService.getDeals(input);
                        deals.then(function(response){
                            if (!response.length ){
                                $scope.defaultMessage = "No Deals Found";
                            }
                            $scope.deals = response;
                            $ionicLoading.hide();
                        });
                    }
                };
                var init = function (){
                    document.getElementById('leftSideMenu').style.visibility = "hidden";
                    var input;
                    if (StorageService.get('loc_group')){
                        input = {city:StorageService.get('loc_group')};
                    }else{
                        input = null;
                    }

                    if (input != null){
                        utils.getDeals(input);
                    }else{
                        if ("geolocation" in navigator){
                            navigator.geolocation.getCurrentPosition(onSuccess, onError);
                        }
                    }


                    $scope.admin = definedVariable.getAdminRootClean();
                    $scope.isAndroid = /(android)/i.test(navigator.userAgent) ? true : false;


                    // console.log(utils.getChallengeList(''));
                }
                init();
                function currentSuccess(position){
                    var inp = {longitude:position.coords.longitude,latitude:position.coords.latitude};
                    var newCountry = dataService.get_challenge_list_by_location(inp);
                    newCountry.then(function(response){

                        $scope.challengeList = response;
                    });
                }
                $scope.changeCity = function(city){
                    $scope.hideCountry();
                    var auth;
                    if (loggedIn != null){
                        auth = loggedIn.auth_token;
                    }else{
                        auth = "";
                    }

                    if (city.group !== null && city.group != "Use Current Location"){

                        var newCountry = dataService.get_challenge_list_by_location({
                            loc_group : city.group
                        });
                        newCountry.then(function(response){

                            $scope.challengeList = response;

                        });
                        StorageService.set('current_user_city',city.city);
                        StorageService.set('current_user_state',city.state);
                        StorageService.set('current_user_country',city.country);
                        StorageService.set('loc_group',city.group);
                        utils.getDeals({city:city.group});

                    }
                    else if (city !== null && city.state !== "" && city.country !== "" && city.city != "Use Current Location"){
                        var newCountry = dataService.get_challenge_list_by_location({
                            city:city.city,
                            state:city.state,
                            country:city.country,
                            auth_token:auth,
                            category_type:''
                        });
                        newCountry.then(function(response){

                            $scope.challengeList = response;

                        });
                        StorageService.set('current_user_city',city.city);
                        StorageService.set('current_user_state',city.state);
                        StorageService.set('current_user_country',city.country);
                        utils.getDeals({city:city.city});

                    }else{
                        if ("geolocation" in navigator){
                            navigator.geolocation.getCurrentPosition(onSuccess, onError);
                        }
                    }


                };

                $scope.countryFilter = false;
                $scope.showCountry = function(){
                    $scope.countryFilter = true;
                };
                $scope.hideCountry = function(){
                    $scope.countryFilter = false;
                };
                $scope.showFilterDetail = function(){
                    $scope.showFilterStatus = false;
                    $scope.modal.show();
                };



                $ionicModal.fromTemplateUrl('templates/sort.html', {
                    scope: $scope
                }).then(function(modal) {
                        $scope.modal = modal;
                    });
                $scope.challengeAvailable = true;
                $scope.$on('challenge:updated', function(event,data) {

                });
                $scope.$watch('deals',function(newValue,oldValue){

                });

                $scope.toggleSideMenu = function(){

                    if ($ionicSideMenuDelegate.isOpenLeft()){
                        $scope.showFilterStatus = false;
                        createBanner();
                        document.getElementById('leftSideMenu').style.visibility = "hidden";
                        //map.setClickable(true);
                        $ionicSideMenuDelegate.toggleRight();
                    }
                    else{
                        $scope.showFilterStatus = false;
                        AdMob.removeBanner();
                        document.getElementById('leftSideMenu').style.visibility = "visible";
                        // map.setClickable(false);
                        $ionicSideMenuDelegate.toggleLeft();

                    }

                };
            });
        }])
;

